;EasyCodeName=RSEdit,1
Comment	'==================================================================='
Comment	'  ste es un completo editor de texto en formato dll y con cdigo  '
Comment	'  fuente, que puede ser modificado y/o mejorado por cualquiera que '
Comment	'  lo utilice. Si lo modifica, por favor enveme el nuevo cdigo.   '
Comment	'                                                                   '
Comment	'   Para cualquier duda puede enviar un correo a las direcciones:   '
Comment	'                                                                   '
Comment	'        asm@easycoder.org	           rsala@easycoder.org          '
Comment	'                                                                   '
Comment	'                    http://www.easycoder.org                       '
Comment	'                                                                   '
Comment	'                 Copyright  2003-2005 Ramon Sala                  '
Comment	'==================================================================='

Public		rsCreateEditor


.Const

;===========================================================================
; RS Edit constants
;===========================================================================

RSC_PREV			Equ		1
RSC_NEXT			Equ		2

RSC_DOWN			Equ		1
RSC_MATCHCASE		Equ		2
RSC_WHOLEWORD		Equ		4


;===========================================================================
; RS Edit events
;===========================================================================

EV_CHANGE			Equ		00000001H
EV_HSCROLL			Equ		00000002H
EV_UPDATE			Equ		00000004H
EV_VSCROLL			Equ		00000008H
EV_SELCHANGE		Equ		00000010H


;===========================================================================
; RS Edit messages
;===========================================================================

RSM_CANPASTE			Equ		WM_USER + 101
RSM_CANREDO				Equ		WM_USER + 102
RSM_CANUNDO				Equ		WM_USER + 103
RSM_CLEARUNDOBUFFER		Equ		WM_USER + 104
RSM_FINDWORD			Equ		WM_USER + 105
RSM_FINDTEXT			Equ		WM_USER + 106
RSM_GETBACKCOLOR		Equ		WM_USER + 107
RSM_GETEVENTMASK		Equ		WM_USER + 108
RSM_GETFIRSTVISIBLELINE Equ		WM_USER + 109
RSM_GETHANDLE			Equ		WM_USER + 110
RSM_GETHIDESELECTION	Equ 	WM_USER + 111
RSM_GETLINE				Equ		WM_USER + 112
RSM_GETLINECOUNT		Equ		WM_USER + 113
RSM_GETLINEFROMCHAR		Equ		WM_USER + 114
RSM_GETLINEINDEX		Equ		WM_USER + 115
RSM_GETLINELENGTH		Equ		WM_USER + 116
RSM_GETMODIFY			Equ		WM_USER + 117
RSM_GETPOSITION			Equ		WM_USER + 118
RSM_GETSELBACKCOLOR		Equ		WM_USER + 119
RSM_GETSELBARCOLOR		Equ		WM_USER + 120
RSM_GETSELBARWIDTH		Equ		WM_USER + 121
RSM_GETSELECTION		Equ		WM_USER + 122
RSM_GETSELTEXT			Equ		WM_USER + 123
RSM_GETSELTEXTCOLOR		Equ		WM_USER + 124
RSM_GETTEXTCOLOR		Equ		WM_USER + 125
RSM_LINESCROLL			Equ		WM_USER + 126
RSM_REDO				Equ		WM_USER + 127
RSM_REPLACESEL			Equ		WM_USER + 128
RSM_SETAUTOINDENT		Equ		WM_USER + 129
RSM_SETBACKCOLOR		Equ		WM_USER + 130
RSM_SETCARETWIDTH		Equ 	WM_USER + 131
RSM_SETEVENTMASK		Equ		WM_USER + 132
RSM_SETFINDPROC			Equ		WM_USER + 133
RSM_SETHIDESELECTION	Equ 	WM_USER + 134
RSM_SETHSCROLLBAR		Equ 	WM_USER + 135
RSM_SETMODIFY			Equ		WM_USER + 136
RSM_SETPAINTPROC		Equ		WM_USER + 137
RSM_SETREADONLY 		Equ		WM_USER + 138
RSM_SETSELBACKCOLOR		Equ		WM_USER + 139
RSM_SETSELBARCOLOR		Equ		WM_USER + 140
RSM_SETSELBARWIDTH		Equ		WM_USER + 141
RSM_SETSELECTION		Equ		WM_USER + 142
RSM_SETSELTEXTCOLOR		Equ		WM_USER + 143
RSM_SETTABSTOPS 		Equ		WM_USER + 144
RSM_SETTEXTCOLOR		Equ		WM_USER + 145
RSM_SETUNDOLIMIT		Equ		WM_USER + 146
RSM_SETVSCROLLBAR		Equ 	WM_USER + 147


.Data?

RSSCHARSEL 			Struct
					lMin			LONG		?
					lMax			LONG		?
RSSCHARSEL 			EndS

RSSSELCHANGED		Struct
					nmhdr			NMHDR		<?>
					chr				RSSCHARSEL 	<?>
					ptPos			POINTL		<?>
RSSSELCHANGED		EndS


RSSFINDTEXT			Struct
					chr				RSSCHARSEL	<?>
					lpstr			LPSTR		?
RSSFINDTEXT			EndS


.Data

;===========================================================================
; Data structure for RS Edit control
;===========================================================================

EDITDATA			Struct
					bAutoIndent			BOOL		FALSE
					bCaret				BOOL		FALSE
					bChanged			BOOL		FALSE
					bHideSelection		BOOL		FALSE
					bHScrollBar			BOOL		TRUE
					bInsert 			BOOL		FALSE
					bModified			BOOL		FALSE
					bReadOnly			BOOL		FALSE
					bSelCol				BOOL		FALSE
					bVScrollBar			BOOL		TRUE
					lCaretWidth			LONG		1
					lCols				LONG		0
					lRows				LONG		0
					lRealCol			LONG		0
					lFirstLine			LONG		0
					lLeftOffset			LONG		0
					lLineIndex			LONG		0
					lFirstLineIndex 	LONG		0
					lHScroll			LONG		0
					lTotalHScroll		LONG		0
					lPageSize			LONG		0
					lRealCols			LONG		0
					lSelCol 			LONG		0
					lSelBarWidth		LONG		0
					lTabStops			LONG		0
					lTextLength			LONG		0
					lBufferLength		LONG		0
					lStart				LONG		0
					lStartPos			LONG		0
					dwEventMask			DWord		0
					hWnd				HWND		NULL
					hWndEditParent		HWND		NULL
					hwndParent			HWND		NULL
					hwndSelBar			HWND		NULL
					lStartModified		LONG		0
					lUndoLimit			LONG		0
					lUndoCount			LONG		0
					lUndoStart			LONG		0
					lpszUndoText		LPSTR		0
					lpUndoBuffer		DWord		NULL
					ptPos				POINTL		<0>
					chrPos				RSSCHARSEL 	<0>
					chrSel				RSSCHARSEL 	<0>
					szFont				SIZEL		<0>
					szSize				SIZEL		<0>
					hFont				HFONT		NULL
					hMem				HDC			NULL
					hBackBrush			HBRUSH		NULL
					hSelBarBrush		HBRUSH		NULL
					hBitmap 			HBITMAP 	NULL
					prFindProc			DWord		NULL
					prPaintProc			DWord		NULL
					crBackColor			COLORREF	0
					crBackSelect		COLORREF	0
					crTextColor			COLORREF	0
					crTextSelect		COLORREF	0
					crSelBarColor		COLORREF	0
					crRealBackColor		COLORREF	0
					crRealTextColor 	COLORREF	0
					crRealBackSelect	COLORREF	0
					crRealTextSelect	COLORREF	0
					lpszLine			LPSTR		NULL
					lpszText			LPSTR		NULL
					lpszMemPtr			LPSTR		NULL
EDITDATA			EndS


szControlClass		Byte 				"RSEditControlClass", 0
szParentClass		Byte 				"RSEditParentClass", 0
szChar				Byte				0, 0, 0
szLineFeed			Byte				13, 10, 0
hInst				HINSTANCE			NULL
sci					SCROLLINFO			<0>


.Code


;===========================================================================
; Macros
;===========================================================================

GetEditData Macro arg
	Assume Ebx:Ptr EDITDATA
	Mov Ebx, arg
EndM


;===========================================================================
; Dll Entry Point
;===========================================================================

DllMain Proc hInstance:HINSTANCE, dwReason:DWord, lpvReserved:LPVOID
	Local wc:WNDCLASSEX

	.If dwReason == DLL_PROCESS_ATTACH
		Mov Eax, hInstance
		Mov hInst, Eax

		Mov wc.hInstance, Eax
		Mov wc.cbSize, SizeOf WNDCLASSEX
		Mov wc.style, CS_GLOBALCLASS
		Mov wc.lpfnWndProc, Offset wndRSEditParentWndProc
		Mov wc.cbClsExtra, 0
		Mov wc.cbWndExtra, 0
		Mov wc.hIcon, NULL
		Invoke LoadCursor, NULL, IDC_ARROW
		Mov wc.hCursor, Eax
		Mov wc.hbrBackground, (COLOR_WINDOW + 1)
		Mov wc.lpszMenuName, NULL
		Mov wc.lpszClassName, Offset szParentClass
		Mov wc.hIconSm, NULL
		Invoke RegisterClassEx, Addr wc

		Mov wc.style, CS_DBLCLKS
		Mov wc.lpfnWndProc, Offset wndRSEditWndProc
		Invoke LoadCursor, NULL, IDC_IBEAM
		Mov wc.hCursor, Eax
		Mov wc.hbrBackground, NULL
		Mov wc.lpszClassName, Offset szControlClass
		Invoke RegisterClassEx, Addr wc

	.ElseIf dwReason == DLL_PROCESS_DETACH
		Invoke UnregisterClass, Offset szControlClass, hInst
		Invoke UnregisterClass, Offset szParentClass, hInst

	.ElseIf dwReason == DLL_THREAD_ATTACH

	.ElseIf dwReason == DLL_THREAD_DETACH

	.EndIf
	Mov Eax, TRUE
	Ret
DllMain EndP


;===========================================================================
; Public Procedures
;===========================================================================

;===========================================================================;
; Name:		rsCreateEditor                                                  ;
; Function:	Creates a new instance of the RS Edit control                   ;
;                                                                           ;
; Params:  	hwndParent = Handle of the parent                               ;
;          	dwStyle    = Normal style (WS_CHILD, WS_VISIBLE, etc.)          ;
;          	dwExStyle  = Extended style (WS_EX_CLIENTEDGE, etc.)            ;
;          	lLeft      = X position (in pixels)                             ;
;          	lTop       = Y position (in pixels)                             ;
;          	lWidth     = Width (in pixels)                                  ;
;          	lHeight    = Height (in pixels)                                 ;
;                                                                           ;
; Returns: The handle of the new created control in EAX                     ;
;===========================================================================;
rsCreateEditor Proc hwndParent:HWND, dwStyle:DWord, dwExStyle:DWord, lLeft:LONG, lTop:LONG, lWidth:LONG, lHeight:LONG
	Or dwStyle, WS_CLIPCHILDREN
	Invoke CreateWindowEx, dwExStyle, Offset szParentClass,
		   NULL, dwStyle, lLeft, lTop, lWidth, lHeight,
		   hwndParent, NULL, hInst, NULL
	Ret
rsCreateEditor EndP


;===========================================================================
; Private Procedures
;===========================================================================

;===========================================================================;
; Name:		rsChangeControlColors                                           ;
; Function:	Changes one or more of the RS Edit control colors               ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;          	lFlags     = Colors that must be changed                        ;
;                                                                           ;
; Bits meaning:		0 = 1 -> Changes the editor background                  ;
;                	1 = 1 -> Changes the selection bar background           ;
;                	2 = 1 -> Changes the editor text color                  ;
;                	3 = 1 -> Changes the editor selection background        ;
;                	4 = 1 -> Changes the editor selection text color        ;
;===========================================================================;
rsChangeControlColors Proc Uses Ebx lpEditData:DWord, lFlags:LONG
	Local rc:RECT

	GetEditData lpEditData
	.If (lFlags & 1)
		Invoke DeleteObject, [Ebx].hBackBrush
		Mov Eax, [Ebx].crRealBackColor
		.If Eax > 00FFFFFFH
			And Eax, 0FFH
			Push Eax
			Invoke GetSysColorBrush, Eax
			Mov [Ebx].hBackBrush, Eax
			Pop Eax
			Invoke GetSysColor, Eax
			Mov [Ebx].crBackColor, Eax
		.Else
			Mov [Ebx].crBackColor, Eax
			Invoke CreateSolidBrush, Eax
			Mov [Ebx].hBackBrush, Eax
		.EndIf
		Invoke SetBkColor, [Ebx].hMem, [Ebx].crBackColor
	.EndIf
	.If (lFlags & 2)
		Invoke DeleteObject, [Ebx].hSelBarBrush
		Mov Eax, [Ebx].crSelBarColor
		.If Eax > 00FFFFFFH
			And Eax, 0FFH
			Invoke GetSysColorBrush, Eax
			Mov [Ebx].hSelBarBrush, Eax
		.Else
			Invoke CreateSolidBrush, Eax
			Mov [Ebx].hSelBarBrush, Eax
		.EndIf
		Invoke InvalidateRect, [Ebx].hwndSelBar, NULL, TRUE
	.EndIf
	.If (lFlags & 4)
		Mov Eax, [Ebx].crRealTextColor
		.If Eax > 00FFFFFFH
			And Eax, 0FFH
			Invoke GetSysColor, Eax
			Mov [Ebx].crTextColor, Eax
		.Else
			Mov [Ebx].crTextColor, Eax
		.EndIf
		Invoke SetTextColor, [Ebx].hMem, [Ebx].crTextColor
	.EndIf
	.If (lFlags & 8)
		Mov Eax, [Ebx].crRealBackSelect
		.If Eax > 00FFFFFFH
			And Eax, 0FFH
			Invoke GetSysColor, Eax
			Mov [Ebx].crBackSelect, Eax
		.Else
			Mov [Ebx].crBackSelect, Eax
		.EndIf
	.EndIf
	.If (lFlags & 16)
		Mov Eax, [Ebx].crRealTextSelect
		.If Eax > 00FFFFFFH
			And Eax, 0FFH
			Invoke GetSysColor, Eax
			Mov [Ebx].crTextSelect, Eax
		.Else
			Mov [Ebx].crTextSelect, Eax
		.EndIf
	.EndIf
	Invoke SetBkMode, [Ebx].hMem, TRANSPARENT
	Invoke SetTextColor, [Ebx].hMem, [Ebx].crRealTextColor
	Invoke GetClientRect, [Ebx].hWndEditParent, Addr rc
	Push Ecx
	Mov Ecx, rc.right
	Mov Eax, rc.bottom
	MakeLong Cx, Ax
	Pop Ecx
	Invoke SendMessage, [Ebx].hWndEditParent, WM_SIZE, 0, Eax
	Invoke rsUpdateControl, [Ebx].hWnd
	Ret
rsChangeControlColors EndP

;===========================================================================;
; Name:		rsCheckModified                                                 ;
; Function:	Checks if text is unmodified due to undo / redo operations      ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;===========================================================================;
rsCheckModified Proc Uses Ebx lpEditData:DWord
	GetEditData lpEditData
	Mov Eax, [Ebx].lUndoCount
	.If Eax == [Ebx].lStartModified
		Mov [Ebx].bModified, FALSE
		Mov [Ebx].bChanged, FALSE
	.EndIf
	Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
	Ret
rsCheckModified EndP

;===========================================================================;
; Name:		rsClearNextUndoEntry                                            ;
; Function:	Clears the undo entry specified by the 'lpUndoCount' member of  ;
;           the RS Edit control's data structure                            ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;===========================================================================;
rsClearNextUndoEntry Proc Uses Ebx Edx Esi lpEditData:DWord
	GetEditData lpEditData
	.If [Ebx].lpUndoBuffer != NULL
		Mov Esi, [Ebx].lpUndoBuffer
		Mov Eax, SizeOf DWord
		Mul [Ebx].lUndoCount
		Add Esi, Eax
		.If DWord Ptr [Esi] != NULL
			Invoke GlobalFree, DWord Ptr [Esi]
			Mov DWord Ptr [Esi], NULL
		.EndIf
	.EndIf
	Ret
rsClearNextUndoEntry EndP

;===========================================================================;
; Name:		rsClearUndoBuffer                                               ;
; Function:	Clears the undo/redo buffer                                     ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;===========================================================================;
rsClearUndoBuffer Proc Uses Ebx Esi lpEditData:DWord
	GetEditData lpEditData
	.If [Ebx].lpUndoBuffer != NULL
		Mov Esi, [Ebx].lpUndoBuffer
		Mov Eax, [Ebx].lUndoLimit
		Or Eax, Eax
		Jnz @F
		Ret
@@:		Push Eax
		.If DWord Ptr [Esi] != NULL
			Invoke GlobalFree, DWord Ptr [Esi]
			Mov DWord Ptr [Esi], Eax
		.EndIf
		Add Esi, SizeOf DWord
		Pop Eax
		Dec Ax
		Jnz @B
		Mov [Ebx].lUndoCount, 0
		Mov [Ebx].lUndoStart, (-1)
		Mov Eax, [Ebx].lpszUndoText
		Mov Word Ptr [Eax], 0
	.EndIf
	Ret
rsClearUndoBuffer EndP

;===========================================================================;
; Name:		rsCopyString                                                    ;
; Function:	Copies an ASCIIZ string into another                            ;
;                                                                           ;
; Params:  lpDest = Destination address of the copy                         ;
; Params:  lpDest = Source address of the copy                              ;
;                                                                           ;
; Returns: The length of the copied string in EAX                           ;
;===========================================================================;
rsCopyString Proc Uses Edi Esi lpDest:LPSTR, lpSource:LPSTR
	Mov Esi, lpSource
	Mov Edi, lpDest
@@:	Mov Al, Byte Ptr [Esi]
	Inc Esi
	Mov Byte Ptr [Edi], Al
	Inc Edi
	Or Al, Al
	Jnz @B
	Dec Edi
	Sub Edi, lpDest
	Mov Eax, Edi
	Ret
rsCopyString EndP

;===========================================================================;
; Name:		rsDecrementUndoCount                                            ;
; Function:	Decrements the undo / redo operations count                     ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;===========================================================================;
rsDecrementUndoCount Proc Uses Ebx Edx lpEditData:DWord
	GetEditData lpEditData
	.If [Ebx].lUndoCount > 0
		Dec [Ebx].lUndoCount
		Mov Eax, [Ebx].lUndoCount
		Mov Edx, SizeOf DWord
		Mul Edx
		Add Eax, [Ebx].lpUndoBuffer
		.If DWord Ptr [Eax] == NULL
			Inc [Ebx].lUndoCount
			Mov Eax, FALSE
		.EndIf
	.Else
		Mov Eax, [Ebx].lUndoLimit
		Dec Eax
		Mov [Ebx].lUndoCount, Eax
		Mov Edx, SizeOf DWord
		Mul Edx
		Add Eax, [Ebx].lpUndoBuffer
		.If DWord Ptr [Eax] == NULL
			Mov [Ebx].lUndoCount, 0
			Mov Eax, FALSE
		.EndIf
	.EndIf
	Ret
rsDecrementUndoCount EndP

rsDiscardBlanks Proc Uses Ecx Edi lpszBuf:LPSTR, lMin:LONG
	Invoke rsGetStringLength, lpszBuf
	Dec Eax
	.If Eax != 0
		Mov Edi, lpszBuf
		Xor Ecx, Ecx
		.While Byte Ptr [Edi + Ecx]
			Mov Al, Byte Ptr [Edi + Ecx]
			.If Al != 10 && Al != 13 && Al != ' ' && Al != 9
				Return 0
			.EndIf
			Inc Ecx
		.EndW
		Mov Eax, Ecx
	.EndIf
	Ret
rsDiscardBlanks EndP

;===========================================================================;
; Name:		rsDisplayCursor                                                 ;
; Function:	Creates a caret and displays it on the screen                   ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;===========================================================================;
rsDisplayCursor Proc Uses Ebx lpEditData:DWord
	GetEditData lpEditData
	.If ![Ebx].bReadOnly
		Invoke CreateCaret, [Ebx].hWnd, NULL, [Ebx].lCaretWidth, [Ebx].szFont.y
		Mov [Ebx].bCaret, FALSE
		Invoke rsSetCaret, lpEditData
	.EndIf
	Ret
rsDisplayCursor EndP

;===========================================================================;
; Name:		rsExpandTabStops                                                ;
; Function:	Converts tabs to spaces                                         ;
;                                                                           ;
; Params:	lpszLine   = Address ob buffer to store spaces                  ;
;          	lpLength   = Address of the current length of lpszLine          ;
;                                                                           ;
; Remarks:	Ebx must point to the RS Edit control's data structure    		;
;  			Edx must point to expanded tabs buffer (lpszLine+length)  		;
;===========================================================================;
rsExpandTabStops Proc Uses Ecx Esi lpLength:DWord
	Mov Esi, lpLength
	Mov Eax, DWord Ptr [Esi]
	Mov Ecx, [Ebx].lTabStops
	Dec Ecx
	And Eax, Ecx
	Inc Ecx
	Sub Ecx, Eax
	Add DWord Ptr [Esi], Ecx
@@:	Mov Byte Ptr [Edx], ' '
	Inc Edx
	Dec Ecx
	Jnz @B
	Ret
rsExpandTabStops EndP

;===========================================================================;
; Name:		rsFindFirstChar                                                 ;
; Function:	Finds the first character not being a control character         ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns: The zero based position of the character inside the line in EAX  ;
;===========================================================================;
rsFindFirstChar Proc Uses Ebx Esi lpEditData:DWord
	GetEditData lpEditData
	Mov Esi, [Ebx].lpszText
	Add Esi, [Ebx].lLineIndex
	Push Esi
	.While Byte Ptr [Esi] != 0
		Mov Al, Byte Ptr [Esi]
		.If Al == 13 || Al > ' '
			.Break
		.EndIf
		Inc Esi
	.EndW
	Mov Eax, Esi
	Pop Esi
	Sub Eax, Esi
	.If Eax == [Ebx].ptPos.x
		Xor Eax, Eax
	.EndIf
	Ret
rsFindFirstChar EndP

;===========================================================================;
; Name:		rsFindHook                                                      ;
; Function:	Called by 'rsIsAlpha' procedure. It can be subclassed by user   ;
;           to decide which characters are treated like a word break or not ;
;                                                                           ;
; Params:	chr = Character to be compared to                               ;
;                                                                           ;
; Returns:  TRUE  = Character is treated like part of word (no word-break)  ;
;           FALSE = Character is interpreted like a word-break              ;
;===========================================================================;
rsFindHook Proc chr:CHAR
	Return FALSE
rsFindHook EndP

;======================================================================;
; Name:		rsFindNextWord                                                  ;
; Function:	Finds the next word after the cursor                            ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lIndex     = Current character index (where the cursor is)      ;
;                                                                           ;
; Returns: The character index of the next word in EAX                      ;
;===========================================================================;
rsFindNextWord Proc Uses Ebx Ecx Esi lpEditData:DWord, lIndex:LONG
	GetEditData lpEditData
	Mov Eax, [Ebx].lTextLength
	.If lIndex < Eax
		Xor Ecx, Ecx
		Mov Esi, [Ebx].lpszText
		Add Esi, lIndex
		.If Byte Ptr [Esi] == 13
			Mov Ecx, 2
			.If Byte Ptr [Esi + Ecx] == 0 || (Byte Ptr [Esi + Ecx] != 9 && Byte Ptr [Esi + Ecx] != ' ')
				Jmp @F
			.EndIf
		.EndIf
		Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
		.If Eax
			.While Eax
				Inc Ecx
				Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.EndW
		.ElseIf Byte Ptr [Esi + Ecx] != 9 && Byte Ptr [Esi + Ecx] != ' ' && Byte Ptr [Esi + Ecx] != 13
			.While Eax == FALSE && Byte Ptr [Esi + Ecx] != ' ' && Byte Ptr [Esi + Ecx] != 9
				.If Byte Ptr [Esi + Ecx] == 10
					Inc Ecx
					Jmp Short @F
				.EndIf
				Inc Ecx
				Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.EndW
		.EndIf
		.If Byte Ptr [Esi + Ecx] == 9 || Byte Ptr [Esi + Ecx] == ' '
			.While Byte Ptr [Esi + Ecx] == 9 || Byte Ptr [Esi + Ecx] == ' '
				Inc Ecx
			.EndW
		.EndIf
@@:		Mov Eax, Esi
		Add Eax, Ecx
		Sub Eax, [Ebx].lpszText
	.EndIf
	Ret
rsFindNextWord EndP

;===========================================================================;
; Name:		rsFindPrevWord                                                  ;
; Function:	Finds the previous word before the cursor                       ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lIndex     = Current character index (where the cursor is)      ;
;                                                                           ;
; Returns: The character index of the previous word in EAX                  ;
;===========================================================================;
rsFindPrevWord Proc Uses Ebx Ecx Esi lpEditData:DWord, lIndex:LONG
	.If lIndex > 1
		GetEditData lpEditData
		Xor Ecx, Ecx
		Mov Esi, [Ebx].lpszText
		Add Esi, lIndex
		Dec Esi
		.If Byte Ptr [Esi + Ecx] == 10
			Sub Ecx, 2
			Mov Eax, Esi
			Sub Eax, 2
			.If Eax <= [Ebx].lpszText
				Jmp @F
			.EndIf
		.EndIf
		.If Byte Ptr [Esi + Ecx] == 9 || Byte Ptr [Esi + Ecx] == ' '
			Dec Ecx
			.While Byte Ptr [Esi + Ecx] == 9 || Byte Ptr [Esi + Ecx] == ' '
				Dec Ecx
			.EndW
			.If Byte Ptr [Esi + Ecx] == 10
				Jmp @F
			.EndIf
		.EndIf
		Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
		.If Eax == FALSE
			Dec Ecx
			Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.While Eax == FALSE && Byte Ptr [Esi + Ecx] != 9 && Byte Ptr [Esi + Ecx] != ' '
				.If Byte Ptr [Esi + Ecx] == 10
					Jmp Short @F
				.ElseIf Byte Ptr [Esi + Ecx] == 13
					Inc Ecx
					Jmp Short @F
				.EndIf
				Dec Ecx
				Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.EndW
		.Else
			Dec Ecx
			Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.While Eax
				.If Byte Ptr [Esi + Ecx] == 10
					.Break ;Jmp Short @F
				.EndIf
				Dec Ecx
				Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.EndW
		.EndIf
@@:		Mov Eax, Esi
		Add Eax, Ecx
		Inc Eax
		Sub Eax, [Ebx].lpszText
		Ret
	.EndIf
	Return 0
rsFindPrevWord EndP

;===========================================================================;
; Name:		rsFindText                                                      ;
; Function:	Finds text according to an RSSFINDTEXT structure 		       	;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lFlags     = Flags for searching                                ;
;           rssFt      = Structure specifying what and how to search        ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in EAX       ;
;===========================================================================;
rsFindText Proc Uses Ebx Ecx Edx Edi Esi lpEditData:DWord, lFlags:LONG, rssFt:DWord
	Local lLength:LONG, lpSearch:LPSTR

	GetEditData lpEditData
	Assume Edi:Ptr RSSFINDTEXT
	Mov Edi, rssFt
	Mov Eax, [Edi].lpstr
	.If Byte Ptr [Eax] == 0
		Mov Eax, (-1)
	.Else
		.If (lFlags & RSC_DOWN)
			Mov Eax, [Ebx].lpszText
			.If [Edi].chr.lMin != (-1)
				Mov Eax, [Ebx].lTextLength
				.If Eax >= [Edi].chr.lMin
					Mov Eax, [Edi].chr.lMin
					Add Eax, [Ebx].lpszText
				.EndIf
			.EndIf
			Mov lpSearch, Eax
			Mov Eax, [Ebx].lTextLength
			.If [Edi].chr.lMax != (-1)
				.If Eax >= [Edi].chr.lMax
					Mov Eax, [Edi].chr.lMax
				.EndIf
				.If [Edi].chr.lMax < Eax
					Inc Eax
				.EndIf
			.EndIf
			Mov Edx, Eax
		.Else
			Mov Eax, [Ebx].lTextLength
			.If [Edi].chr.lMin > Eax || [Edi].chr.lMin == (-1)
				Mov Ecx, Eax
				Invoke rsGetStringLength, [Edi].lpstr
				Sub Ecx, Eax
				Add Ecx, [Ebx].lpszText
				Mov lpSearch, Ecx
			.Else
				Mov Eax, [Edi].chr.lMin
				Dec Eax
				Add Eax, [Ebx].lpszText
				Mov lpSearch, Eax
			.EndIf
			Mov Eax, [Ebx].lTextLength
			.If [Edi].chr.lMax > Eax || [Edi].chr.lMax == (-1)
				Xor Edx, Edx
			.Else ;If [Edi].chr.lMax < 80000000H ;> 0
				Mov Edx, [Edi].chr.lMax
				.If Edx != 0
					Dec Edx
				.EndIf
			.EndIf
		.EndIf
		Mov Esi, [Ebx].lpszText
		Mov Al, Byte Ptr [Esi + Edx]
		Push Eax
		Cmp Edx, 0
		Je @F
		Cmp Edx, (-1)
		Je @F
		Mov Byte Ptr [Esi + Edx], 0
@@:		Invoke rsGetStringLength, [Edi].lpstr
		Mov lLength, Eax
		Xor Eax, Eax
		.While Eax != (-1)
			Invoke rsSearchText, [Edi].lpstr, lFlags, [Ebx].lpszText, lpSearch
			Mov Ecx, Eax
			.If Eax == (-1)
				.Break
			.EndIf
			;Mov Eax, lFlags
			;And Eax, RSC_WHOLEWORD
			.If (lFlags & RSC_WHOLEWORD) ;Eax
				Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx - 1], [Ebx].prFindProc
				.If Ecx == 0 || !Eax
					Mov Eax, Ecx
					Add Eax, lLength
					.If Eax > [Ebx].lTextLength
						Mov Eax, FALSE
					.Else
						Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Eax], [Ebx].prFindProc
					.EndIf
					.If !Eax
						.Break
					.EndIf
				.EndIf
				;Mov Eax, lFlags
				;And Eax, RSC_DOWN
				.If (lFlags & RSC_DOWN) ;Eax
					Mov Eax, [Ebx].lpszText
					Add Eax, Ecx
					;Add Eax, lLength
					Inc Eax
				.Else
					Mov Eax, [Ebx].lpszText
					Add Eax, Ecx
					;Add Eax, lLength
					Dec Eax
				.EndIf
				Mov lpSearch, Eax
			.Else
				.Break
			.EndIf
		.EndW
		Pop Eax
		Mov Byte Ptr [Esi + Edx], Al
	.EndIf
	Assume Edi:Nothing
	Return Ecx
rsFindText EndP

;===========================================================================;
; Name:	    rsGetLineAndExpandTabs                                          ;
; Function: Gets the line in the 'lpszLine' member buffer of the RS Edit    ;
;           control data structure, with expanded tabs, ready to be painted ;
;                                                                           ;
; Params:   lpEditData = Address of the RS Edit control's data structure    ;
;           lIndex     = Character index of the line to be retreived        ;
;           chr        = Address of a CHARSEL structure                     ;
;                                                                           ;
; Returns: The length of the expanded line in EAX                           ;
;===========================================================================;
rsGetLineAndExpandTabs Proc Uses Ebx Ecx Edx Esi Edi lpEditData:DWord, lIndex:LONG, chr:DWord
	Local l1:LONG, lLength:LONG
	Local lMin:LONG, lMax:LONG
	Local bMin:BOOL, bMax:BOOL

	Mov bMin, FALSE
	Mov bMax, FALSE
	GetEditData lpEditData
	Assume Edi:Ptr RSSCHARSEL
	Mov Edi, chr
	Mov Eax, [Ebx].lRealCol
	Mov [Edi].lMin, Eax
	Mov [Edi].lMax, Eax
	Invoke rsGetLineLength, lpEditData, lIndex
	Mov l1, Eax
	.If l1 > 1024
		Mov l1, 1024
	.EndIf
	Mov Eax, [Ebx].chrPos.lMin
	.If Eax < [Ebx].chrPos.lMax
		Mov Ecx, lIndex
		Add Ecx, l1
		.If Eax >= lIndex && Eax < Ecx
			Mov bMin, TRUE
			Mov bMax, TRUE
			.If lIndex < Eax
				Sub Eax, lIndex
				Mov [Edi].lMin, Eax
			.Else
				Mov [Edi].lMin, 0
			.EndIf
			.If [Ebx].chrPos.lMax >= Ecx
				Mov Eax, l1
				Mov [Edi].lMax, Eax
			.Else
				Mov Eax, [Ebx].chrPos.lMax
				Sub Eax, lIndex
				Mov [Edi].lMax, Eax
			.EndIf
		.Else
			Mov Eax, [Ebx].chrPos.lMax
			.If Eax > lIndex && Eax <= Ecx
				Mov bMin, TRUE
				Mov bMax, TRUE
				Mov [Edi].lMin, 0
				Sub Eax, lIndex
				Mov [Edi].lMax, Eax
			.Else
				Mov Eax, [Ebx].chrPos.lMin
				.If Eax <= lIndex && [Ebx].chrPos.lMax >= Ecx
					Mov bMin, TRUE
					Mov bMax, TRUE
					Mov [Edi].lMin, 0
					Mov Eax, l1
					Mov [Edi].lMax, Eax
				.EndIf
			.EndIf
		.EndIf
	.EndIf
	Mov lLength, 0
	Mov Esi, [Ebx].lpszText
	Add Esi, lIndex
	Mov Edx, [Ebx].lpszLine
	.If l1 == 0
		Mov [Ebx].lRealCol, 0
	.Else
		Xor Ecx, Ecx
		.While Ecx < l1
			.If bMin
				.If [Edi].lMin == Ecx
					Mov bMin, FALSE
					Mov Eax, lLength
					Mov [Edi].lMin, Eax
				.EndIf
			.EndIf
			.If bMax
				.If [Edi].lMax == Ecx
					Mov bMax, FALSE
					Mov Eax, lLength
					Mov [Edi].lMax, Eax
				.EndIf
			.EndIf
			Mov Eax, [Ebx].ptPos.x
			.If Ecx == Eax
				Mov Eax, lLength
				Mov [Ebx].lRealCol, Eax
			.EndIf
			Mov Al, Byte Ptr [Esi + Ecx]
			.If Al == 9
				Invoke rsExpandTabStops, Addr lLength
			.Else
				Mov Byte Ptr [Edx], Al
				Inc Edx
				Inc lLength
			.EndIf
			Inc Ecx
		.EndW
		.If bMax && [Edi].lMax == Ecx
			Mov Eax, lLength
			Mov [Edi].lMax, Eax
		.EndIf
	.EndIf
	Mov Byte Ptr [Edx], 0
	Assume Edi:Nothing
	Mov Eax, lLength
	Ret
rsGetLineAndExpandTabs EndP

;===========================================================================;
; Name:		rsGetLineFromChar                                               ;
; Function:	Gets the zero based line number for the given index             ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lIndex     = Character index whose number is to be retreived    ;
;           bLineIndex = If TRUE, the new line index is stored in the       ;
;                        'lLineIndex' member of the data structure          ;
;                                                                           ;
; Returns: The zero based line for the indicated index                      ;
;===========================================================================;
rsGetLineFromChar Proc Uses Ebx Edi lpEditData:DWord, lIndex:LONG, bLineIndex:BOOL
	Local lpszTemp:LPSTR

	GetEditData lpEditData
	Cmp lIndex, 0
	Jg @F
	Xor Eax, Eax
	.If bLineIndex
		Mov [Ebx].lLineIndex, Eax
	.EndIf
	Ret
@@:	Mov Eax, [Ebx].lTextLength
	.If lIndex >= Eax
		Mov Edi, [Ebx].lpszText
		Add Edi, Eax
		Mov Eax, [Ebx].lRows
		Dec Eax
	.Else ;If lIndex > 0
		Mov Eax, [Ebx].lpszText
		Mov Edi, Eax
		Add Eax, lIndex
		Mov lpszTemp, Eax
		Mov Eax, [Ebx].lFirstLineIndex
		Add Edi, Eax
		.If lIndex < Eax
			Mov Eax, [Ebx].lFirstLine
			Mov lIndex, Eax
			.While Edi > lpszTemp
				Cmp Byte Ptr [Edi], 10
				Jne @F
				Dec lIndex
@@:				Dec Edi
			.EndW
			Mov Eax, lIndex
		.Else
			Mov Eax, [Ebx].lFirstLine
			Mov lIndex, Eax
			.While Edi < lpszTemp
				Cmp Byte Ptr [Edi], 10
				Jne @F
				Inc lIndex
@@:				Inc Edi
			.EndW
			Mov Eax, lIndex
		.EndIf
	.EndIf
	.If bLineIndex
		.While Byte Ptr [Edi] != 10
			Dec Edi
		.EndW
		Inc Edi
		Sub Edi, [Ebx].lpszText
		Mov [Ebx].lLineIndex, Edi
	.EndIf
	Ret
rsGetLineFromChar EndP

;===========================================================================;
; Name:		rsGetLineIndex                                                  ;
; Function:	Gets the line index for the given line                          ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lLine      = Line number whose line index is to be retreived    ;
;                                                                           ;
; Returns: The line index for the indicated line                            ;
;===========================================================================;
rsGetLineIndex Proc Uses Ebx lpEditData:DWord, lLine:LONG
	Local lIndex:LONG, lpszTemp:LPSTR

	Cmp lLine, 0
	Jg @F
	Xor Eax, Eax
	Ret
@@:	GetEditData lpEditData
	Mov Eax, [Ebx].lRows
	.If lLine < Eax
		Mov Eax, [Ebx].lpszText
		Mov lpszTemp, Eax
		Mov Eax, [Ebx].lFirstLine
		.If lLine < Eax
			Sub Eax, lLine
			Mov lLine, Eax
			Mov Eax, [Ebx].lFirstLineIndex
			Mov lIndex, Eax
			.While lLine
				Invoke rsGetPrevLineIndex, lpEditData, lIndex
				Mov lIndex, Eax
				Dec lLine
			.EndW
		.ElseIf lLine > Eax
			Sub lLine, Eax
			Mov Eax, [Ebx].lFirstLineIndex
			Mov lIndex, Eax
			.While lLine
				Invoke rsGetNextLineIndex, lpEditData, lIndex
				Mov lIndex, Eax
				Dec lLine
			.EndW
		.Else
			Mov Eax, [Ebx].lFirstLineIndex
		.EndIf
	.Else
		Mov Eax, [Ebx].lTextLength
		Invoke rsGetPrevLineIndex, lpEditData, Eax
	.EndIf
	Ret
rsGetLineIndex EndP

;===========================================================================;
; Name:		rsGetLineLength                                                 ;
; Function:	Gets the line length for the given index                        ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lIndex     = Index of a char belonging to the line whose length ;
;                        is to be retreived                                 ;
;                                                                           ;
; Returns: The length of the line (including the carriage return) in EAX    ;
;===========================================================================;
rsGetLineLength Proc Uses Ebx Ecx lpEditData:DWord, lIndex:LONG
	Cmp lIndex, 0
	Jge @F
	Xor Eax, Eax
	Ret
@@:	GetEditData lpEditData
	Mov Eax, [Ebx].lTextLength
	.If lIndex < Eax
		Mov Eax, [Ebx].lpszText
		Add Eax, lIndex
		.If lIndex != 0 && Byte Ptr [Eax - 1] != 10
			Dec Eax
			.While Byte Ptr [Eax] != 10
				Dec Eax
			.EndW
			Inc Eax
		.EndIf
		Push Eax
@@:		Inc Eax
		Cmp Byte Ptr [Eax], 10
		Jne @B
		Pop Ecx
		Sub Eax, Ecx
	.Else
		Xor Eax, Eax
	.EndIf
	Ret
rsGetLineLength EndP

;===========================================================================;
; Name:		rsGetMemoryPosition                                             ;
; Function:	Gets the zero based position inside the line of the char stored ;
;           in the 'ptPos.x' member (column) of the data structure          ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns: The zero based position of the char in memory in EAX             ;
;===========================================================================;
rsGetMemoryPosition Proc Uses Ebx Ecx Edx Esi lpEditData:DWord
	Local l1:LONG, lTabs:LONG

	GetEditData lpEditData
	Invoke rsGetLineLength, lpEditData, [Ebx].lLineIndex
	.If Eax != 0
		Mov l1, Eax
		Mov Eax, [Ebx].lTabStops
		Mov lTabs, Eax
		Dec lTabs
		Xor Ecx, Ecx
		Xor Edx, Edx
		Mov Esi, [Ebx].lpszText
		Add Esi, [Ebx].lLineIndex
		.While Ecx < l1
			.If Edx == [Ebx].ptPos.x
				Mov Eax, Ecx
				.Break
			.EndIf
			.If Byte Ptr [Esi + Ecx] != 9
				Inc Edx
			.Else
				Push Edx
				And Edx, lTabs
				Mov Eax, [Ebx].lTabStops
				Sub Eax, Edx
				Pop Edx
				.While Al > 0
					Inc Edx
					.If Edx == [Ebx].ptPos.x
						.Break
					.EndIf
					Dec Al
				.EndW
			.EndIf
			.If Edx == [Ebx].ptPos.x
				Inc Ecx
				Mov Eax, Ecx
				.Break
			.EndIf
			Inc Ecx
		.EndW
		.If Ecx >= l1
			Mov Eax, l1
			Dec Eax
		.EndIf
	.EndIf
	Mov [Ebx].ptPos.x, Eax
	Ret
rsGetMemoryPosition EndP

;===========================================================================;
; Name:		rsGetNextLineIndex                                              ;
; Function:	Gets the next line index (beginning of the next line)           ;
;                                                                           ;
; Params:	lpEditData    = Address of the RS Edit control's data structure ;
;           lCurrentIndex = Current line index (line index of current line) ;
;                                                                           ;
; Returns: The next line index in EAX                                       ;
;===========================================================================;
rsGetNextLineIndex Proc Uses Ebx lpEditData:DWord, lCurrentIndex:LONG
	GetEditData lpEditData
	Mov Eax, [Ebx].lTextLength
	.If lCurrentIndex < Eax
		Mov Eax, [Ebx].lpszText
		Add Eax, lCurrentIndex
@@:		Cmp Byte Ptr [Eax], 10
		Je Short @F
		Inc Eax
		Jmp Short @B
@@:		.If Eax >= [Ebx].lTextLength
			Mov Eax, [Ebx].lTextLength
		.Else
			Inc Eax
			Sub Eax, [Ebx].lpszText
		.EndIf
	.EndIf
	Ret
rsGetNextLineIndex EndP

;===========================================================================;
; Name:		rsGetPrevLineIndex                                              ;
; Function:	Gets the previous line index (beginning of the previous line)   ;
;                                                                           ;
; Params:	lpEditData    = Address of the RS Edit control's data structure ;
;           lCurrentIndex = Current line index (line index of current line) ;
;                                                                           ;
; Returns: The previous line index in EAX                                   ;
;===========================================================================;
rsGetPrevLineIndex Proc Uses Ebx lpEditData:DWord, lCurrentIndex:LONG
	.If lCurrentIndex > 1 ;!= 0
		GetEditData lpEditData
		Mov Eax, [Ebx].lpszText
		.If Eax < lCurrentIndex
			Add Eax, lCurrentIndex
			Sub Eax, 2
;			Cmp Byte Ptr [Eax], 13
;			Je Short @F
;			Dec Eax
@@:			Cmp Byte Ptr [Eax], 10
			Je Short @F
			Dec Eax
			Cmp Eax, [Ebx].lpszText
			Jge Short @B
@@:			Inc Eax
			Sub Eax, [Ebx].lpszText
		.Else
			Xor Eax, Eax
		.EndIf
	.Else
		Xor Eax, Eax
	.EndIf
	Ret
rsGetPrevLineIndex EndP

;===========================================================================;
; Name:		rsGetRealColWidth                                               ;
; Function:	Gets the real column width (with tabs expanded) in pixels       ;
;                                                                           ;
; Returns: The length of the entire line in pixels                          ;
;===========================================================================;
rsGetRealColWidth Proc Uses Ebx Ecx lpEditData:DWord
	Local sz:SIZEL, chr:RSSCHARSEL

	GetEditData lpEditData
	.If [Ebx].lRealCols > 0
		Invoke rsGetLineAndExpandTabs, lpEditData, [Ebx].lLineIndex, Addr chr
		Invoke GetTextExtentPoint32, [Ebx].hMem, [Ebx].lpszLine, [Ebx].lRealCol, Addr sz
		Return sz.x
	.EndIf
	Return 0
rsGetRealColWidth EndP

;===========================================================================;
; Name:		rsGetStringLength                                               ;
; Function:	Gets the length of an ASCIIZ string (saving Ecx and Edx)        ;
;                                                                           ;
; Params:  lpszBuf = Address of the string whose length is to be retreived  ;
;                                                                           ;
; Returns: The length of indicated string in EAX                            ;
;===========================================================================;
rsGetStringLength Proc Uses Ecx Edx lpszBuf:LPSTR
	Invoke lstrlen, lpszBuf
	Ret
rsGetStringLength EndP

;===========================================================================;
; Name:		rsInitEditor                                                    ;
; Function:	Initializes the RS Edit's data structure                        ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lLength    = Length of the text in the editor or -1. If -1,     ;
;                        the length is unknown and has to be retreived      ;
;===========================================================================;
rsInitEditor Proc Uses Ebx lpEditData:DWord, lLength:LONG
	GetEditData lpEditData
	.If lLength == (-1)
		Invoke lstrlen, [Ebx].lpszText
		Mov [Ebx].lTextLength, Eax
	.EndIf
	Mov [Ebx].bModified, FALSE
	Invoke lstrcat, [Ebx].lpszText, Addr szLineFeed
	Invoke rsGetLineLength, lpEditData, 0
	Dec Eax
	.If Eax >= 80000000H ;< 0
		Xor Eax, Eax
	.EndIf
	Mov [Ebx].lCols, Eax
	Mov [Ebx].lLeftOffset, 0
	Mov [Ebx].lRealCol, 0
	Mov [Ebx].lRealCols, 0
	Mov [Ebx].lFirstLine, 0
	Mov [Ebx].lFirstLineIndex, 0
	Mov [Ebx].ptPos.x, 0
	Mov [Ebx].ptPos.y, 0
	Mov [Ebx].chrPos.lMin, 0
	Mov [Ebx].chrPos.lMax, 0
	Mov [Ebx].chrSel.lMin, 0
	Mov [Ebx].chrSel.lMax, 0
	Mov [Ebx].lSelCol, 0
	Invoke rsSetRows, lpEditData
	Invoke rsClearUndoBuffer, lpEditData
	Ret
rsInitEditor EndP

;===========================================================================;
; Name:		rsInsertText                                                    ;
; Function:	Inserts text (or removes it) in the RS Edit control's memory    ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lpszChar   = Addres of text to be inserted                      ;
;                                                                           ;
; Returns:  The length of the inserted text                                 ;
;===========================================================================;
rsInsertText Proc Uses Ebx Ecx lpEditData:DWord, lpszChar:LPSTR
	Local lRows:LONG, lLength:LONG
	Local lTemp:LONG, lpszTemp:LPSTR

	Xor Ecx, Ecx
	Mov lRows, Ecx
	Mov lTemp, Ecx
	Mov Eax, lpszChar
	.While Byte Ptr [Eax] != 0
		Cmp Byte Ptr [Eax], 10
		Jne @F
		Inc lRows
		.Break
@@:		Inc Eax
	.EndW
	GetEditData lpEditData
	.If lRows == 0
		Mov Ecx, [Ebx].chrPos.lMin
		.If [Ebx].chrPos.lMax > Ecx
			Mov Eax, [Ebx].lpszText
			.While Ecx < [Ebx].chrPos.lMax
				Cmp Byte Ptr [Eax + Ecx], 10
				Jne @F
				Inc lRows
				.Break
@@:				Inc Ecx
			.EndW
		.EndIf
	.EndIf
	Invoke rsGetStringLength, lpszChar
	Mov lLength, Eax
	Mov Ecx, [Ebx].chrPos.lMax
	Sub Ecx, [Ebx].chrPos.lMin
	Sub Eax, Ecx
	Mov lTemp, Eax
	Add Eax, [Ebx].lTextLength
	Add Eax, 3
	Cmp Eax, [Ebx].lBufferLength
	Jl @F
	Sub Eax, [Ebx].lBufferLength
	Invoke rsResizeTextBuffer, lpEditData, Eax
@@:	Mov Eax, [Ebx].lpszText
	Add Eax, [Ebx].chrPos.lMin
	Push Eax
	Add Eax, lLength
	Mov lpszTemp, Eax
	Mov Ecx, [Ebx].lpszText
	Add Ecx, [Ebx].chrPos.lMax
	Mov Eax, [Ebx].lTextLength
	Sub Eax, [Ebx].chrPos.lMax
	Add Eax, 3
	Invoke rsMoveMemory, lpszTemp, Ecx, Eax
	Pop Ecx
	.If lLength > 0
		Invoke rsMoveMemory, Ecx, lpszChar, lLength
	.EndIf
	Mov Eax, lTemp
	Add [Ebx].lTextLength, Eax
	.If lRows > 0
		Invoke rsSetRows, lpEditData
	.EndIf
	Mov Eax, lLength
	Ret
rsInsertText EndP

;===========================================================================;
; Name:		rsIsAlpha                                                       ;
; Function:	Specifies whether a character is a letter or not                ;
;                                                                           ;
; Params:	chr        = Character to check                                 ;
;           prFindProc = Address of the FindProc function                   ;
;                                                                           ;
; Returns:  TRUE if chr is an alpha character, FALSE if not                 ;
;===========================================================================;
rsIsAlpha Proc chr:CHAR, prFindProc:DWord
	.If chr > 64 && chr < 91
		Return TRUE
	.ElseIf chr > 96 && chr < 123
		Return TRUE
	.ElseIf chr > 191 ; || chr == '_' || chr == '@' || chr == '$' || chr == '#'
		Return TRUE
	.EndIf
	Mov Al, chr
	Push Eax
	Call prFindProc
	Ret
rsIsAlpha EndP

;===========================================================================;
; Name:		rsIsAlphaNumeric                                                ;
; Function:	Specifies whether a character is alphanumeric or not            ;
;                                                                           ;
; Params:	chr        = Character to check                                 ;
;           prFindProc = Address of the FindProc function                   ;
;                                                                           ;
; Returns:  TRUE if chr is a letter or o number, FALSE if not               ;
;===========================================================================;
rsIsAlphaNumeric Proc chr:CHAR, prFindProc:DWord
	Invoke rsIsAlpha, chr, prFindProc
	.If Eax
		Ret
	.ElseIf chr > 47 && chr < 58
		Return TRUE
	.EndIf
	Return FALSE
rsIsAlphaNumeric EndP

;===========================================================================;
; Name:		rsLineScroll                                                    ;
; Function:	Scrolls controls' text the specified number of columns/lines    ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lCols      = Number of columns to be scrolled                   ;
;           lLines     = Number of lines to be scrolled                     ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;                                                                           ;
; Remarks:  To scroll to left or top, specify negative values               ;
;===========================================================================;
rsLineScroll Proc lpEditData:DWord, lCols:LONG, lLines:LONG
	Local lTemp:LONG

	GetEditData lpEditData
	.If lLines != 0
		Mov Eax, [Ebx].lFirstLine
		Add Eax, lLines
		Mov lTemp, Eax
		.If Eax >= 80000000H ;< 0
			Mov lTemp, 0
		.Else
			Mov Eax, [Ebx].lRows
			Sub Eax, [Ebx].lPageSize
			.If lTemp > Eax
				Mov Eax, [Ebx].lRows
				Dec Eax
				Sub Eax, [Ebx].lPageSize
				Mov lTemp, Eax
				.If Eax >= 80000000H ;< 0
					Mov lTemp, 0
				.EndIf
			.EndIf
		.EndIf
		Invoke rsGetLineIndex, lpEditData, lTemp
		Mov [Ebx].lFirstLineIndex, Eax
		Mov Eax, lTemp
		Mov [Ebx].lFirstLine, Eax
	.EndIf
	.If lCols != 0
		.If [Ebx].bHScrollBar
			Invoke GetScrollInfo, [Ebx].hWndEditParent, SB_HORZ, Addr sci
		.EndIf
		Mov Eax, [Ebx].lLeftOffset
		Add Eax, lCols
		Mov [Ebx].lLeftOffset, Eax
		.If Eax > 1024
			Mov [Ebx].lLeftOffset, 1023
		.ElseIf [Ebx].lLeftOffset >= 80000000H ;< 0
			Mov [Ebx].lLeftOffset, 0
		.EndIf
		Mov Eax, [Ebx].lLeftOffset
		Mov sci.nPos, Eax
		.If [Ebx].bHScrollBar
			Invoke SetScrollInfo, [Ebx].hWndEditParent, SB_HORZ, Addr sci, TRUE
		.EndIf
	.EndIf
	Ret
rsLineScroll EndP

;===========================================================================;
; Name:		rsMakeSelectionVisible                                          ;
; Function:	Sets the best line index for the first visible line, in order   ;
;           to center the word in the indexes indicated by 'lStart - lEnd'  ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lPos       = Character index to check for                       ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsMakeSelectionVisible Proc Uses Ecx Edx lpEditData:DWord, lStart:LONG, lEnd:LONG
	Local lLine1:LONG, lLine2:LONG, lLines:LONG

	GetEditData lpEditData
	Invoke rsGetLineFromChar, lpEditData, lStart, FALSE
	Mov lLine1, Eax
	Invoke rsGetLineFromChar, lpEditData, lEnd, FALSE
	Mov lLine2, Eax
	Xor Edx, Edx
	Mov Eax, [Ebx].szSize.y
	Div [Ebx].szFont.y
	Mov lLines, Eax
	Mov Eax, [Ebx].lFirstLine
	Mov Edx, Eax
	Add Edx, lLines
	.If lLine2 >= Eax && lLine2 <= Edx
		Ret
	.EndIf
	Mov Edx, lLines
	Shr Edx, 1
	Mov Eax, lLine2
	Sub Eax, lLine1
	Cmp Eax, lLines
	Jle @F
	Mov Eax, lLine2
	Sub Eax, Edx
	Mov lLine1, Eax
@@:	Mov Eax, lLine1
	Sub Eax, Edx
	Sub Eax, [Ebx].lFirstLine
	Invoke rsLineScroll, lpEditData, 0, Eax
	Ret
rsMakeSelectionVisible EndP

;===========================================================================;
; Name:		rsMoveMemory                                                    ;
; Function:	Moves 'lCount' bytes from 'lpszSource' to 'lpszDest'            ;
;                                                                           ;
; Params:	lpszSource = Address of the source of data to be moved          ;
;           lpszDest   = Address of the destination where to move to        ;
;           lCount     = Number of bytes to be moved                        ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsMoveMemory Proc Uses Ecx Esi Edi lpszDest:LPSTR, lpszSource:LPSTR, lCount:LONG
	Mov Ecx, lCount
	Cmp Ecx, 0
	Jg @F
	Ret
@@:	Mov Edi, lpszDest
	Mov Esi, lpszSource
	.If Edi > Esi
		Dec Ecx
		Add Esi, Ecx
		Add Edi, Ecx
		Inc Ecx
@@:	   	Mov Al, Byte Ptr [Esi]
	    Dec Esi
	    Mov Byte Ptr [Edi], Al
	    Dec Edi
	    Dec Ecx
		Jnz @B
	.Else
@@:	    Mov Al, Byte Ptr [Esi]
	    Inc Esi
	    Mov Byte Ptr [Edi], Al
	    Inc Edi
	    Dec Ecx
		Jnz @B
	.EndIf
	Ret
rsMoveMemory EndP

;===========================================================================;
; Name:		rsPaintControl                                                  ;
; Function:	Paints the entire RS Edit control (processes WM_PAINT)          ;
;                                                                           ;
; Params:   lpEditData = Address of the control's data                      ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;                                                                           ;
; Remarks:  If an address for a 'Paint proc' has been set (refer to message ;
;           RSM_SETPAINTPROC) RSEdit gives control to that procedure and    ;
;           does not paint anything.                                        ;
;===========================================================================;
rsPaintControl Proc Uses Ebx Ecx Edx lpEditData:DWord
	Local lLength:LONG, lTop:LONG, lBottom:LONG
	Local lCurrentLine:LONG, lIndex:LONG
	Local lRealCol:LONG, chr:RSSCHARSEL
	Local sz:SIZEL, ps:PAINTSTRUCT

	GetEditData lpEditData
	Invoke GetUpdateRect, [Ebx].hWnd, NULL, FALSE
	.If Eax
		Invoke BeginPaint, [Ebx].hWnd, Addr ps
		.If [Ebx].prPaintProc != NULL
			Lea Eax, ps
			Push Eax
			Call [Ebx].prPaintProc
		.Else
			Xor Eax, Eax
			Mov ps.rcPaint.left, Eax
			Mov ps.rcPaint.top, Eax
			Mov Eax, ps.rcPaint.bottom
			Mov lBottom, Eax
			Mov ps.rcPaint.bottom, 2
			Invoke FillRect, ps.hdc, Addr ps.rcPaint, [Ebx].hBackBrush
			Mov lTop, 2
			Mov Eax, ps.rcPaint.right
			Sub Eax, ps.rcPaint.left
			Mov ps.rcPaint.right, Eax
			Mov Eax, [Ebx].lTotalHScroll
			Add ps.rcPaint.right, Eax
			Add ps.rcPaint.left, Eax
			Mov Eax, [Ebx].szFont.y
			Mov ps.rcPaint.bottom, Eax
			Mov Eax, [Ebx].lRealCol
			Mov lRealCol, Eax
			Mov Eax, [Ebx].lFirstLine
			Mov lCurrentLine, Eax
			Mov Eax, [Ebx].lFirstLineIndex
			Mov lIndex, Eax
			Mov Eax, lTop
			.While Eax < lBottom
				Invoke rsGetLineAndExpandTabs, lpEditData, lIndex, Addr chr
				Mov lLength, Eax
				.If Eax
					Invoke GetTextExtentPoint32, [Ebx].hMem, [Ebx].lpszLine, lLength, Addr sz
				.Else
					Mov sz.x, 0
				.EndIf
				Invoke FillRect, [Ebx].hMem, Addr ps.rcPaint, [Ebx].hBackBrush
				Mov Eax, [Ebx].lTotalHScroll
				.If sz.x > Eax
					Mov Eax, chr.lMax
					.If chr.lMin < Eax && ![Ebx].bHideSelection
						Invoke rsSetSelectionColor, lpEditData, lLength, chr
					.Else
						.If lLength > 1
							Dec lLength
							Invoke TextOut, [Ebx].hMem, 0, 0, [Ebx].lpszLine, lLength
						.EndIf
					.EndIf
				.EndIf
				Invoke rsGetNextLineIndex, lpEditData, lIndex
				Mov lIndex, Eax
				Invoke BitBlt, ps.hdc, 0, lTop, ps.rcPaint.right, [Ebx].szFont.y, [Ebx].hMem, [Ebx].lTotalHScroll, 0, SRCCOPY
				Inc lCurrentLine
				Mov Eax, lTop
				Add Eax, [Ebx].szFont.y
				Mov lTop, Eax
			.EndW
			Mov Eax, lRealCol
			Mov [Ebx].lRealCol, Eax
		.EndIf
		Invoke EndPaint, [Ebx].hWnd, Addr ps
	.EndIf
	Ret
rsPaintControl EndP

;===========================================================================;
; Name:		rsProcessLButtonDown                                            ;
; Function:	Processes WM_LBUTTONDOWN message                                ;
;                                                                           ;
; Params:	lpEditData  = Address of the RS Edit control's data structure   ;
;           wMsg        = Value of uMsg parameter                           ;
;           wParam      = Value of wParam parameter                         ;
;			lParam      = Value of lParam parameter                         ;
;                                                                           ;
; Returns:  The character index where the mouse clicked                     ;
;===========================================================================;
rsProcessLButtonDown Proc Uses Ebx Ecx lpEditData:DWord, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local l:LONG, l1:LONG, lX:LONG
	Local pt:POINTL, sz:SIZEL, chr1:RSSCHARSEL

	GetEditData lpEditData
	Mov Eax, [Ebx].lTextLength
	Mov pt.x, Eax
	LoWord lParam
	Cwde
	Mov lX, Eax
	HiWord lParam
	Cwde
	Cdq
	IDiv [Ebx].szFont.y
	Add Eax, [Ebx].lFirstLine
	Mov pt.y, Eax
	Cmp Eax, [Ebx].lRows
	Jl @F
	Mov Eax, pt.x
	Jmp rs3
@@:	Invoke rsGetLineIndex, Ebx, Eax
	Mov [Ebx].lLineIndex, Eax
	Mov Ecx, Eax
	Invoke rsGetLineAndExpandTabs, Ebx, Ecx, Addr chr1
	Dec Eax
	Mov pt.x, Eax
	Mov [Ebx].ptPos.x, Eax
	Cmp Eax, 0
	Jle rs2
	Mov Ecx, 1
	Mov l, Ecx
	.While Ecx <= pt.x
		Invoke GetTextExtentPoint32, [Ebx].hMem, [Ebx].lpszLine, l, Addr sz
		Mov Eax, lX
		Add Eax, [Ebx].lTotalHScroll
		Cmp Eax, sz.x
		Jg rs1
		Mov l1, Eax
		Mov Eax, sz.x
		Sub Eax, l1
		Mov l1, Eax
		Dec l
		Mov Ecx, [Ebx].lpszLine
		Add Ecx, l
		Invoke GetTextExtentPoint32, [Ebx].hMem, Ecx, 1, Addr sz
		Mov Eax, sz.x
		Shr Eax, 1
		Cmp Eax, l1
		Jl @F
		Inc l
@@:		.Break
rs1:	Inc l
		Mov Ecx, l
	.EndW
	Mov Eax, l
	Mov [Ebx].ptPos.x, Eax
rs2:Invoke rsGetMemoryPosition, Ebx
	Add Eax, [Ebx].lLineIndex
	Mov pt.x, Eax
rs3:.If (wParam & MK_SHIFT)
		Mov Eax, [Ebx].chrSel.lMin
		Mov [Ebx].chrPos.lMin, Eax
		Mov Eax, pt.x
	.EndIf
	.If (wParam & MK_CONTROL)
		.If uMsg == WM_LBUTTONDOWN && !(wParam & MK_SHIFT)
			Mov Ecx, [Ebx].chrPos.lMin
			.If Ecx == [Ebx].chrPos.lMax || Eax < Ecx || Eax > [Ebx].chrPos.lMax
				Invoke rsSelectWord, Ebx, Eax, FALSE
				Mov Eax, [Ebx].chrPos.lMax
			.Else
				Mov [Ebx].chrPos.lMin, Eax
			.EndIf
		.Else
			Invoke rsSelectWord, Ebx, [Ebx].chrSel.lMin, TRUE
			Mov Eax, [Ebx].chrSel.lMin
			.If Eax == [Ebx].chrSel.lMax
				.If pt.x > Eax
					Mov Eax, [Ebx].chrPos.lMin
				.Else
					Mov Eax, [Ebx].chrPos.lMax
				.EndIf
			.Else
				.If pt.x > Eax
					Mov Eax, [Ebx].chrPos.lMin
				.Else
					.If Eax > [Ebx].chrPos.lMax
						Mov Eax, [Ebx].chrSel.lMin
					.Else
						Mov Eax, [Ebx].chrPos.lMax
					.EndIf
				.EndIf
			.EndIf
			Mov pt.y, Eax
			Invoke rsSelectWord, Ebx, pt.x, TRUE
			Mov Eax, [Ebx].chrSel.lMin
			.If pt.x > Eax
				Mov Eax, [Ebx].chrPos.lMax
			.Else
				Mov Eax, [Ebx].chrPos.lMin
			.EndIf
			Mov pt.x, Eax
			Push pt.y
			Pop [Ebx].chrPos.lMin
		.EndIf
	.ElseIf !(wParam & MK_SHIFT)
		Mov [Ebx].chrPos.lMin, Eax
	.EndIf
	Mov [Ebx].chrPos.lMax, Eax
	Mov [Ebx].bSelCol, TRUE
	Ret
rsProcessLButtonDown EndP

;===========================================================================;
; Name:		rsRedoAction                                                    ;
; Function:	Performs a redo action (if any)                                 ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsRedoAction Proc Uses Ebx Edx Edi Esi lpEditData:DWord
	Local lMin:LONG

	GetEditData lpEditData
	Mov Eax, FALSE
	.If [Ebx].lpUndoBuffer != NULL
		Mov Esi, [Ebx].lpUndoBuffer
		Mov Eax, SizeOf DWord
		Mul [Ebx].lUndoCount
		Add Esi, Eax
		.If DWord Ptr [Esi] == NULL
			Mov Eax, FALSE
		.Else
			Mov [Ebx].bSelCol, TRUE
			Push [Ebx].dwEventMask
			Mov [Ebx].dwEventMask, 0
			Invoke SendMessage, [Ebx].hWnd, WM_SETREDRAW, FALSE, 0
			Invoke GlobalLock, DWord Ptr [Esi]
			Mov Edi, Eax
			Push Edi
			Mov Eax, DWord Ptr [Edi] ; lMin
			Mov [Ebx].chrPos.lMin, Eax
			Mov Eax, DWord Ptr [Edi + 4] ;lMax
			Mov [Ebx].chrPos.lMax, Eax
			Add Edi, 8
			Invoke rsGetStringLength, Edi
			Add Edi, Eax
			Inc Edi
			Invoke rsGetStringLength, Edi
			Push Eax
			Invoke rsDiscardBlanks, Edi, [Ebx].chrPos.lMin
			Mov lMin, Eax
			Invoke rsReplaceSelection, lpEditData, Edi, (-1)
			Pop Edx
			Pop Edi
			Invoke rsSetFirstLineIndex, lpEditData
			Invoke rsMakeSelectionVisible, lpEditData, DWord Ptr [Edi + 4], DWord Ptr [Edi]
			Mov Eax, [Ebx].lUndoCount
			Inc Eax
			.If Eax >= [Ebx].lUndoLimit
				Mov [Ebx].lUndoCount, 0
			.Else
				Mov [Ebx].lUndoCount, Eax
			.EndIf
			Mov Ecx, DWord Ptr [Edi]
			Add Edx, Ecx
			Inc Ecx
			.If Ecx != Edx
				Dec Ecx
			.EndIf
			Add Ecx, lMin
			Mov [Ebx].lLeftOffset, 0 ;???????
			Invoke rsSetSelection, lpEditData, Ecx, Edx
			Invoke GlobalUnlock, DWord Ptr [Esi]
			Invoke SendMessage, [Ebx].hWnd, WM_SETREDRAW, TRUE, 0
			Invoke rsCheckModified, lpEditData
			Pop [Ebx].dwEventMask
			Invoke rsSendNotifyMessage, lpEditData, EN_SELCHANGE
			Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			Mov Eax, TRUE
		.EndIf
	.EndIf
	Ret
rsRedoAction EndP

;===========================================================================;
; Name:		rsReplaceSelection                                              ;
; Function:	Replaces selected text with text specified by lpszChar          ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lpszChar   = Address of new text                                ;
;           lKey       = Key code for undo action (-1 if no undo)           ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;                                                                           ;
; Remarks:  If there is no text selected, the new text is inserted in the   ;
;           caret's position (the insertion point)                          ;
;===========================================================================;
rsReplaceSelection Proc Uses Ebx lpEditData:DWord, lpszChar:LPSTR, lKey:LONG
	Mov [Ebx].bSelCol, TRUE
	GetEditData lpEditData
	.If [Ebx].bReadOnly
		Ret
	.EndIf
	.If lKey != (-1)
		Invoke rsStoreUndoText, lpEditData, lpszChar
	.EndIf
	Mov Eax, [Ebx].dwEventMask
	And Eax, EV_UPDATE
	.If Eax
		Mov Eax, EN_UPDATE
		Shl Eax, 16
		Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, [Ebx].hWnd
	.EndIf
	Invoke rsInsertText, lpEditData, lpszChar
	Add Eax, [Ebx].chrPos.lMin
	Mov [Ebx].chrPos.lMin, Eax
	Mov [Ebx].chrPos.lMax, Eax
	Mov [Ebx].bModified, TRUE
	Mov [Ebx].bChanged, TRUE
	.If lKey != -1
		Invoke rsSetSelection, lpEditData, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
	.EndIf
	Mov [Ebx].bChanged, FALSE
	Mov Eax, [Ebx].dwEventMask
	And Eax, EV_CHANGE
	.If Eax
		Mov Eax, EN_CHANGE
		Shl Eax, 16
		Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, [Ebx].hWnd
	.EndIf
	Ret
rsReplaceSelection EndP

;===========================================================================;
; Name:		rsResizeTextBuffer                                              ;
; Function:	Resizes text buffer to fit the new text length                  ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           lBytes     = Number of bytes to be add                          ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsResizeTextBuffer Proc Uses Ebx lpEditData:DWord, lBytes:LONG
	Local dwBytes:DWord, hHandle:HANDLE

	GetEditData lpEditData
	Invoke GetTempPath, MAX_PATH, [Ebx].lpszLine
	Mov dwBytes, Eax
	Dec Eax
	Add Eax, [Ebx].lpszLine
	.If Byte Ptr [Eax] != '\'
		Text szBackSlash, "\"
		Invoke lstrcat, [Ebx].lpszLine, Addr szBackSlash
	.EndIf
	Text szTempFileName, "RSEDTTXT.TMP"
	Invoke lstrcat, [Ebx].lpszLine, Addr szTempFileName
	Invoke CreateFile, [Ebx].lpszLine, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	Mov hHandle, Eax
	Invoke WriteFile, hHandle, [Ebx].lpszText, [Ebx].lTextLength, Addr dwBytes, NULL
	Invoke CloseHandle, hHandle
	Invoke	VirtualFree, [Ebx].lpszMemPtr, 0, MEM_RELEASE
	.If lBytes < 1022
		Mov Eax, 1024
	.Else
		Mov Eax, lBytes
	.EndIf
	Add Eax, [Ebx].lBufferLength
	Mov [Ebx].lBufferLength, Eax
	Inc Eax
	Invoke VirtualAlloc, 0, Eax, MEM_COMMIT, PAGE_READWRITE
	Mov [Ebx].lpszMemPtr, Eax
	Mov Byte Ptr [Eax], 10
	Inc Eax
	Mov [Ebx].lpszText, Eax
	Invoke CreateFile, [Ebx].lpszLine, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	Mov hHandle, Eax
	Invoke ReadFile, hHandle, [Ebx].lpszText, [Ebx].lTextLength, Addr dwBytes, NULL
	Invoke CloseHandle, hHandle
	Invoke lstrcat, [Ebx].lpszText, Addr szLineFeed
	Invoke DeleteFile, [Ebx].lpszLine
	Ret
rsResizeTextBuffer EndP

;===========================================================================;
; Name:		rsSaveUndoBufer                                                 ;
; Function:	Saves the undo buffer contents (one key strokes)                ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsSaveUndoBuffer Proc Uses Ebx lpEditData:DWord
	Local chr:RSSCHARSEL

	GetEditData lpEditData
	Mov Eax, [Ebx].chrPos.lMin
	Mov chr.lMin, Eax
	Mov Eax, [Ebx].chrPos.lMax
	Mov chr.lMax, Eax
	Mov Eax, [Ebx].lUndoStart
	Mov [Ebx].chrPos.lMin, Eax
	Mov [Ebx].chrPos.lMax, Eax
	Invoke rsSaveUndoRedoText, lpEditData, [Ebx].lpszUndoText
	Mov Eax, [Ebx].lpszUndoText
	Mov Byte Ptr [Eax], 0
	Mov [Ebx].lUndoStart, (-1)
	Mov Eax, chr.lMin
	Mov [Ebx].chrPos.lMin, Eax
	Mov Eax, chr.lMax
	Mov [Ebx].chrPos.lMax, Eax
	Ret
rsSaveUndoBuffer EndP

;===========================================================================;
; Name:		rsSaveUndoRedoText                                              ;
; Function:	Saves blocks of text for undo / redo operations                 ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           szNewText  = Address of new text                                ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsSaveUndoRedoText Proc Uses Ebx Edx Esi lpEditData:DWord, szNewText:LPSTR
	Local lSize1:LONG, lSize2:LONG, lpch:LPSTR

	GetEditData lpEditData
	.If [Ebx].lpUndoBuffer != NULL
		Mov Esi, [Ebx].lpUndoBuffer
		Mov Eax, SizeOf DWord
		Mul [Ebx].lUndoCount
		Add Esi, Eax
		Mov Eax, [Ebx].chrPos.lMax
		Sub Eax, [Ebx].chrPos.lMin
		Mov lSize1, Eax
		Invoke rsGetStringLength, szNewText
		Mov lSize2, Eax
		.If lSize1 > 0 || lSize2 > 0
			.If DWord Ptr [Esi] != NULL
				Invoke GlobalFree, DWord Ptr [Esi]
				Mov DWord Ptr [Esi], NULL
			.EndIf
			Mov Eax, lSize1
			Add Eax, lSize2
			Add Eax, 10
			Invoke GlobalAlloc, GMEM_MOVEABLE Or GMEM_DDESHARE Or GMEM_ZEROINIT, Eax
			Mov DWord Ptr [Esi], Eax
			Invoke GlobalLock, Eax
			Mov lpch, Eax
			Add lpch, 8
			Mov Edx, [Ebx].chrPos.lMin
			Mov DWord Ptr [Eax], Edx
			Mov Edx, [Ebx].chrPos.lMax
			Mov DWord Ptr [Eax + 4], Edx
			Inc lSize1
			Mov Eax, [Ebx].lpszText
			Add Eax, [Ebx].chrPos.lMin
			Invoke lstrcpyn, lpch, Eax, lSize1
			Inc lSize2
			Mov Eax, lpch
			Add Eax, lSize1
			Invoke lstrcpyn, Eax, szNewText, lSize2
			Invoke GlobalUnlock, DWord Ptr [Esi]
			Inc [Ebx].lUndoCount
			Mov Eax, [Ebx].lUndoCount
			.If Eax >= [Ebx].lUndoLimit
				Mov [Ebx].lUndoCount, 0
			.EndIf
			Invoke rsCheckModified, lpEditData
			Invoke rsClearNextUndoEntry, lpEditData
		.EndIf
	.EndIf
	Ret
rsSaveUndoRedoText EndP

;===========================================================================;
; Name:		rsSearchCaseDown                                                ;
; Function:	Searches text down (case sensitive) from a specified position   ;
;                                                                           ;
; Params:	lpText   = Buffer containing text to search for                 ;
;           lpSearch = Address for buffer where to start searching          ;
;           lPointer = Address of the first char in controls' text buffer   ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in Eax       ;
;===========================================================================;
rsSearchCaseDown Proc Uses Ecx Edx Edi Esi lpText:LPSTR, lpSearch:LPSTR, lPointer:LONG
	Mov Esi, lpSearch
	Mov Edi, lpText
	Xor Ecx, Ecx
	Mov Edx, Esi
rsD1:
	Mov Ah, Byte Ptr [Edi + Ecx]
	Or Ah, Ah
	Jz rsD5
	Mov Al, Byte Ptr [Esi] ;Lodsb
	Inc Esi
	Or Al, Al
	Jnz rsD2
	Xor Eax, Eax
	Dec Eax
	Ret
rsD2:
	Cmp Al, Ah
	Jne rsD3
	Inc Ecx
	Jmp rsD1
rsD3:
	Or Ecx, Ecx
	Jnz rsD4
	Mov Edx, Esi
	Jmp rsD1
rsD4:
	Inc Edx
	Mov Esi, Edx
	Xor Ecx, Ecx
	Jmp rsD1
rsD5:
	Mov Eax, Edx
	Sub Eax, lPointer
	Ret
rsSearchCaseDown EndP

;===========================================================================;
; Name:		rsSearchCaseUp                                                  ;
; Function:	Searches text up (case sensitive) from a specified position     ;
;                                                                           ;
; Params:	lpText   = Buffer containing text to search for                 ;
;           lpSearch = Address for buffer where to start searching          ;
;           lPointer = Address of the first char in controls' text buffer   ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in EAX       ;
;===========================================================================;
rsSearchCaseUp Proc Uses Ecx Edx Edi Esi lpText:LPSTR, lpSearch:LPSTR, lPointer:LONG
	Mov Esi, lpSearch
	Mov Edi, lpText
	Xor Ecx, Ecx
	Mov Edx, Esi
rsU1:
	Mov Ah, Byte Ptr [Edi + Ecx]
	Or Ah, Ah
	Jz rsU4
	Cmp Esi, lPointer
	Jnc rsU2
	Xor Eax, Eax
	Dec Eax
	Ret
rsU2:
	Mov Al, Byte Ptr [Esi] ;Lodsb
	Inc Esi
	Cmp Al, Ah
	Jne rsU3
	Inc Ecx
	Jmp rsU1
rsU3:
	Xor Ecx, Ecx
	Dec Edx
	Mov Esi, Edx
	Jmp rsU1
rsU4:
	Mov Eax, Edx
	Sub Eax, lPointer
	Ret
rsSearchCaseUp EndP

;===========================================================================;
; Name:		rsSearchNoCaseDown                                              ;
; Function:	Searches text down (case insensitive) from a specified position ;
;                                                                           ;
; Params:	lpText   = Buffer containing text to search for                 ;
;           lpSearch = Address for buffer where to start searching          ;
;           lPointer = Address of the first char in controls' text buffer   ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in EAX       ;
;===========================================================================;
rsSearchNoCaseDown Proc Uses Ecx Edx Edi Esi lpText:LPSTR, lpSearch:LPSTR, lPointer:LONG
	Mov Esi, lpSearch
	Mov Edi, lpText
	Xor Ecx, Ecx
	Mov Edx, Esi
rsND1:
	Mov Ah, Byte Ptr [Edi + Ecx]
	Or Ah, Ah
	Jz rsND7
	Mov Al, Byte Ptr [Esi] ;Lodsb
	Inc Esi
	Or Al, Al
	Jnz rsND2
	Xor Eax, Eax
	Dec Eax
	Ret
rsND2:
	Cmp Al, Ah
	Je rsND4
	Cmp Ah, 65
	Jc rsND5
	Cmp Ah, 91
	Jc rsND3
	Cmp Ah, 97
	Jc rsND5
	Cmp Ah, 123
	Jc rsND3
	Cmp Ah, 192
	Jc rsND5
	Cmp Ah, 215
	Je rsND5
rsND3:
	Or Ax, 8224
	Cmp Al, Ah
	Jne rsND5
rsND4:
	Inc Ecx
	Jmp rsND1
rsND5:
	Or Ecx, Ecx
	Jnz rsND6
	Mov Edx, Esi
	Jmp rsND1
rsND6:
	Inc Edx
	Mov Esi, Edx
	Xor Ecx, Ecx
	Jmp rsND1
rsND7:
	Mov Eax, Edx
	Sub Eax, lPointer
	Ret
rsSearchNoCaseDown EndP

;===========================================================================;
; Name:		rsSearchNoCaseUp                                                ;
; Function:	Searches text up (case insensitive) from a specified position   ;
;                                                                           ;
; Params:	lpText   = Buffer containing text to search for                 ;
;           lpSearch = Address for buffer where to start searching          ;
;           lPointer = Address of the first char in controls' text buffer   ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in EAX       ;
;===========================================================================;
rsSearchNoCaseUp Proc Uses Ecx Edx Edi Esi lpText:LPSTR, lpSearch:LPSTR, lPointer:LONG
	Mov Esi, lpSearch
	Mov Edi, lpText
	Xor Ecx, Ecx
	Mov Edx, Esi
rsNU1:
	Mov Ah, Byte Ptr [Edi + Ecx]
	Or Ah, Ah
	Jz rsNU8
	Cmp Esi, lPointer
	Jnc rsNU3
rsNU2:
	Xor Eax, Eax
	Dec Eax
	Ret
rsNU3:
	Mov Al, Byte Ptr [Esi] ;Lodsb
	Inc Esi
	Or Al, Al
	Jz rsNU2
	Cmp Al, Ah
	Je rsNU6
	Cmp Ah, 65
	Jc rsNU7
	Cmp Ah, 91
	Jc rsNU5
	Cmp Ah, 97
	Jc rsNU7
	Cmp Ah, 123
	Jc rsNU5
	Cmp Ah, 192
	Jc rsNU7
	Cmp Ah, 215
	Je rsNU7
rsNU5:
	Or Ax, 8224
	Cmp Al, Ah
	Jne rsNU7
rsNU6:
	Inc Ecx
	Jmp Short rsNU1
rsNU7:
	Xor Ecx, Ecx
	Dec Edx
	Mov Esi, Edx
	Jmp Short rsNU1
rsNU8:
	Mov Eax, Edx
	Sub Eax, lPointer
	Ret
rsSearchNoCaseUp EndP

;===========================================================================;
; Name:		rsSearchText                                                    ;
; Function:	Searches text according to flags and RSSFINDTEXT structure      ;
;                                                                           ;
; Params:	lpText   = Buffer containing text to search for                 ;
;           lFlags   = Flags indicating how to search text                  ;
;           lPointer = Address of the first char in controls' text buffer   ;
;           lpSearch = Address for buffer where to start searching          ;
;                                                                           ;
; Returns:  The character index of the text or -1 if not found in EAX       ;
;===========================================================================;
rsSearchText Proc lpText:LPSTR, lFlags:LONG, lPointer:LONG, lpSearch:LPSTR
	Mov Eax, lpText
	.If Byte Ptr [Eax] == 0
		Return (-1)
	.EndIf
	Mov Eax, lFlags
	And Eax, RSC_MATCHCASE
	.If Eax
		Mov Eax, lFlags
		And Eax, RSC_DOWN
		.If Eax
			Invoke rsSearchCaseDown, lpText, lpSearch, lPointer
		.Else
			Invoke rsSearchCaseUp, lpText, lpSearch, lPointer
		.EndIf
	.Else
		Mov Eax, lFlags
		And Eax, RSC_DOWN
		.If Eax
			Invoke rsSearchNoCaseDown, lpText, lpSearch, lPointer
		.Else
			Invoke rsSearchNoCaseUp, lpText, lpSearch, lPointer
		.EndIf
	.EndIf
	Ret
rsSearchText EndP

;============================================================================;
; Name:		rsSelectWord                                                     ;
; Function:	Fills the 'chrPos' member of the edit data structure with the    ;
;           character indexes of the word which is in the position specified ;
;           by 'lPos' parameter. If there is no word, it fills the 'chrPos'  ;
;           member with the value specified by 'lPos' parameter.             ;
;                                                                            ;
; Params:	lpEditData = Address of the RS Edit control's data structure     ;
;           lPos       = Character index of any part of the text             ;
;			bSpaces    = Specifies whether spaces and tabs (blanks) will be  ;
;                      = taken into account (TRUE = Yes).                    ;
;                                                                            ;
; Returns:  Nothing                                                          ;
;============================================================================;
rsSelectWord Proc Uses Ebx Ecx Esi lpEditData:DWord, lPos:LONG, bSpaces:BOOL
	Local ch1:CHAR, ch2:CHAR

	GetEditData lpEditData
	Mov Esi, [Ebx].lpszText
	Mov Ecx, lPos
	Mov Al, Byte Ptr [Esi + Ecx]
	Mov ch1, Al
	Mov Al, Byte Ptr [Esi + Ecx - 1]
	Mov ch2, Al
	.If !bSpaces && (ch1 == ' ' || ch1 == 9) && (ch2 == ' ' || ch2 == 9)
		Mov [Ebx].chrPos.lMin, Ecx
		Mov [Ebx].chrPos.lMax, Ecx
	.ElseIf ch2 == 10
		Mov [Ebx].chrPos.lMin, Ecx
		Mov Eax, TRUE
		.While Eax
			Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
			.If !Eax
				.Break
			.EndIf
			Inc Ecx
		.EndW
		Mov [Ebx].chrPos.lMax, Ecx
	.ElseIf ch1 == 13
		Mov [Ebx].chrPos.lMax, Ecx
		Invoke rsFindPrevWord, Ebx, Ecx
		Mov [Ebx].chrPos.lMin, Eax
	.Else
		.If ch1 != ' ' && ch1 != 9
			Invoke rsIsAlphaNumeric, ch1, [Ebx].prFindProc
			.If Eax
				Invoke rsIsAlphaNumeric, ch2, [Ebx].prFindProc
				.If Eax
					Invoke rsFindPrevWord, Ebx, Ecx
					Mov Ecx, Eax
				.EndIf
				Mov [Ebx].chrPos.lMin, Ecx
				Mov Eax, TRUE
				.While Eax
					Inc Ecx
					Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
				.EndW
				Mov [Ebx].chrPos.lMax, Ecx
			.Else
				.If bSpaces
					Invoke rsIsAlphaNumeric, ch2, [Ebx].prFindProc
					.If Eax
						Invoke rsFindPrevWord, Ebx, Ecx
						Mov [Ebx].chrPos.lMin, Eax
						Mov Ecx, Eax
						Mov Eax, TRUE
						.While Eax
							Inc Ecx
							Invoke rsIsAlphaNumeric, Byte Ptr [Esi + Ecx], [Ebx].prFindProc
						.EndW
						Mov [Ebx].chrPos.lMax, Ecx
						Ret
					.EndIf
				.EndIf
				Mov Eax, lPos
				Mov [Ebx].chrPos.lMin, Eax
				Mov Ecx, [Ebx].chrSel.lMin
				.If Ecx == [Ebx].chrSel.lMax
					Inc Eax
				.EndIf
				Mov [Ebx].chrPos.lMax, Eax
			.EndIf
		.Else
			Invoke rsIsAlphaNumeric, ch2, [Ebx].prFindProc
			.If Eax
				Mov [Ebx].chrPos.lMax, Ecx
				Invoke rsFindPrevWord, Ebx, Ecx
				Mov [Ebx].chrPos.lMin, Eax
			.Else
				Mov Eax, lPos
				Mov [Ebx].chrPos.lMin, Eax
				Mov Ecx, [Ebx].chrSel.lMin
				.If Ecx == [Ebx].chrSel.lMax
					Dec Eax
				.EndIf
				Mov [Ebx].chrPos.lMax, Eax
			.EndIf
		.EndIf
	.EndIf
	Ret
rsSelectWord EndP

;===========================================================================;
; Name:		rsSendNotifyMessage                                             ;
; Function:	Sends a WM_NOTIFY message to the parent window                  ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;           uCode      = The code of the message (NM_CLICK, NM_DBLCLK, etc.);
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsSendNotifyMessage Proc Uses Ebx Ecx lpEditData:DWord, uCode:UINT
	Local sch:RSSSELCHANGED

	GetEditData lpEditData
	Mov Eax, [Ebx].hWnd
	Mov sch.nmhdr.hwndFrom, Eax
	Mov sch.nmhdr.idFrom, 0
	Mov Eax, uCode
	Mov sch.nmhdr.code, Eax
	.If uCode == EN_SELCHANGE
		Mov Eax, [Ebx].lRealCol
		Mov sch.ptPos.x, Eax
		Mov Eax, [Ebx].ptPos.y
		Mov sch.ptPos.y, Eax
		Mov Eax, [Ebx].chrPos.lMin
		Mov sch.chr.lMin, Eax
		Mov Eax, [Ebx].chrPos.lMax
		Mov sch.chr.lMax, Eax
	.EndIf
	Mov Ecx, uCode
	Shl Ecx, 16
	Invoke SendMessage, [Ebx].hwndParent, WM_NOTIFY, Ecx, Addr sch
	Ret
rsSendNotifyMessage EndP

;===========================================================================;
; Name:		rsSetCaret                                                      ;
; Function:	Positions the caret in the x, y coordinates (specified by the   ;
;           members 'ptPos.x' and 'ptPos.y' of the data structure)          ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsSetCaret Proc Uses Ebx Ecx Edx lpEditData:DWord
	Local pt:POINTL

	GetEditData lpEditData
	.If ![Ebx].bReadOnly
		Invoke rsGetRealColWidth, lpEditData
		Cmp Eax, 0
		Jl @F
		Sub Eax, [Ebx].lTotalHScroll
@@:		Mov pt.x, Eax
		Mov Ecx, [Ebx].szFont.y
		Mov Eax, [Ebx].ptPos.y
		Sub Eax, [Ebx].lFirstLine
		Mul Ecx
		Add Eax, 2
		Mov pt.y, Eax
		Invoke SetCaretPos, pt.x, pt.y
		Mov Eax, [Ebx].chrPos.lMin
		.If Eax == [Ebx].chrPos.lMax
			.If ![Ebx].bCaret
				Mov [Ebx].bCaret, TRUE
				Invoke ShowCaret, [Ebx].hWnd
			.EndIf
		.Else
			.If [Ebx].bCaret
				Mov [Ebx].bCaret, FALSE
				Invoke HideCaret, [Ebx].hWnd
			.EndIf
		.EndIf
	.EndIf
	Ret
rsSetCaret EndP

rsSetCursorCoordinates Proc Uses Ebx lpEditData:DWord
	Local chr:RSSCHARSEL

	GetEditData lpEditData
	Invoke rsGetLineFromChar, lpEditData, [Ebx].chrSel.lMax, TRUE
	Mov [Ebx].ptPos.y, Eax
	Invoke rsGetLineLength, lpEditData, [Ebx].lLineIndex
	.If Eax != 0
		Dec Eax
	.EndIf
	Mov [Ebx].lCols, Eax
	Mov Eax, [Ebx].chrSel.lMax
	Sub Eax, [Ebx].lLineIndex
	Cmp Eax, 0
	Jge @F
	Xor Eax, Eax
@@:	Mov [Ebx].ptPos.x, Eax
	Invoke rsGetLineAndExpandTabs, lpEditData, [Ebx].lLineIndex, Addr chr
	Mov [Ebx].lRealCols, Eax
	Ret
rsSetCursorCoordinates EndP

;===========================================================================;
; Name:		rsSetFirstLineIndex                                             ;
; Function:	Sets the line index for the first visible line                  ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsSetFirstLineIndex Proc Uses Ebx lpEditData:DWord
	GetEditData lpEditData
	Mov Eax, [Ebx].lFirstLine
	Push Eax
	Mov [Ebx].lFirstLine, 0
	Mov [Ebx].lFirstLineIndex, 0
	Invoke rsGetLineIndex, lpEditData, Eax
	Mov [Ebx].lFirstLineIndex, Eax
	Pop Eax
	Mov [Ebx].lFirstLine, Eax
	Invoke rsSetCursorCoordinates, lpEditData
	Ret
rsSetFirstLineIndex EndP

rsSetPosition Proc Uses Ebx Ecx Esi lpEditData:DWord, lMin:LONG, lMax:LONG
	Local bChanged:BOOL

	GetEditData lpEditData
	Mov bChanged, FALSE
	Mov Esi, [Ebx].lpszText
	Mov Eax, lMin
	Cmp Byte Ptr [Esi + Eax], 10
	Jne @F
	Dec Eax
@@:	Cmp Eax, [Ebx].chrSel.lMin
	Je @F
	Mov bChanged, TRUE
@@:	Cmp Eax, [Ebx].lTextLength
	Jle @F
	Mov Eax, [Ebx].lTextLength
@@:	Mov [Ebx].chrSel.lMin, Eax
	Mov Ecx, lMax
	Cmp Byte Ptr [Esi + Ecx], 10
	Jne @F
	Dec Ecx
@@:	Cmp Ecx, [Ebx].chrSel.lMax
	Je @F
	Mov bChanged, TRUE
@@:	Cmp Ecx, [Ebx].lTextLength
	Jle @F
	Mov Ecx, [Ebx].lTextLength
@@:	Mov [Ebx].chrSel.lMax, Ecx
	Cmp Ecx, Eax
	Je @F
	Mov [Ebx].bChanged, TRUE
@@:	Jge @F
	Mov [Ebx].chrPos.lMax, Eax
	Mov [Ebx].chrPos.lMin, Ecx
	Return bChanged
@@:	Mov [Ebx].chrPos.lMin, Eax
	Mov [Ebx].chrPos.lMax, Ecx
	Return bChanged
rsSetPosition EndP

rsSetRows Proc Uses Ebx Esi lpEditData:DWord
	GetEditData lpEditData
	Mov Esi, [Ebx].lpszText
	Xor Eax, Eax
	Mov [Ebx].lRows, Eax
	Mov Ah, 10
rsR1:
	Cmp Byte Ptr [Esi], Al
	Jne rsR2
	Ret
rsR2:
	Cmp Byte Ptr [Esi], Ah
	Jne rsR3
	Inc [Ebx].lRows
rsR3:
	Inc Esi
	Jmp rsR1
	Ret
rsSetRows EndP

rsSetSelection Proc Uses Ebx Ecx Edx lpEditData:DWord, lMin:LONG, lMax:LONG
	Local bChanged:BOOL

	GetEditData lpEditData
	Invoke rsSetPosition, lpEditData, lMin, lMax
	Mov bChanged, Eax
	Invoke rsSetCursorCoordinates, lpEditData
	Mov Eax, [Ebx].lFirstLine
	Add Eax, [Ebx].lPageSize
	.If [Ebx].ptPos.y > Eax
		Mov Ecx, [Ebx].ptPos.y
		Sub Ecx, Eax
		Invoke rsLineScroll, lpEditData, 0, Ecx
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		Mov [Ebx].bChanged, FALSE
	.Else
		Mov Ecx, [Ebx].ptPos.y
		.If Ecx < [Ebx].lFirstLine
			Sub Ecx, [Ebx].lFirstLine
			Invoke rsLineScroll, lpEditData, 0, Ecx
			Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			Mov [Ebx].bChanged, FALSE
		.EndIf
	.EndIf
	Invoke rsUpdateScrollBars, lpEditData, TRUE
	.If [Ebx].bChanged
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
	.EndIf
	.If [Ebx].bSelCol
		Mov [Ebx].bSelCol, FALSE
		Mov Eax, [Ebx].lRealCol
		Mov [Ebx].lSelCol, Eax
	.EndIf
	Invoke rsSetCaret, lpEditData
	.If bChanged
		Mov Eax, [Ebx].dwEventMask
		And Eax, EV_SELCHANGE
		.If Eax
			Invoke rsSendNotifyMessage, lpEditData, EN_SELCHANGE
		.EndIf
	.EndIf
	Ret
rsSetSelection EndP

rsSetSelectionColor Proc Uses Ebx Edx lpEditData:DWord, lLength:LONG, chr:RSSCHARSEL
	Local lBytes:LONG, sz:SIZEL

	GetEditData lpEditData
	.If chr.lMin > 0
		Invoke TextOut, [Ebx].hMem, 0, 0, [Ebx].lpszLine, chr.lMin
		Invoke GetTextExtentPoint32, [Ebx].hMem, [Ebx].lpszLine, chr.lMin, Addr sz
	.Else
		Mov sz.x, 0
	.EndIf
	Mov Eax, lLength
	.If chr.lMax < Eax
		Mov Eax, chr.lMax
	.EndIf
	Mov lBytes, Eax
	Mov Eax, lLength
	Dec Eax
	Add Eax, [Ebx].lpszLine
	Mov Byte Ptr [Eax], ' '
	Push Eax
	Invoke SetBkMode, [Ebx].hMem, OPAQUE
	Invoke SetBkColor, [Ebx].hMem, [Ebx].crBackSelect
	Invoke SetTextColor, [Ebx].hMem, [Ebx].crTextSelect
	.If chr.lMin == 0
		Invoke TextOut, [Ebx].hMem, 0, 0, [Ebx].lpszLine, lBytes
	.Else
		Mov Eax, chr.lMin
		Sub lBytes, Eax
		Add Eax, [Ebx].lpszLine
		Invoke TextOut, [Ebx].hMem, sz.x, 0, Eax, lBytes
	.EndIf
	Invoke SetBkColor, [Ebx].hMem, [Ebx].crBackColor
	Invoke SetTextColor, [Ebx].hMem, [Ebx].crRealTextColor
	Invoke SetBkMode, [Ebx].hMem, TRANSPARENT
	Mov Eax, chr.lMax
	.If Eax < lLength
		Mov Edx, chr.lMin
		Add Edx, [Ebx].lpszLine
		Push sz.x
		Invoke GetTextExtentPoint32, [Ebx].hMem, Edx, lBytes, Addr sz
		Pop Eax
		Add sz.x, Eax
		Mov Eax, lLength
		Dec Eax
		Sub Eax, chr.lMax
		Mov lBytes, Eax
		Mov Eax, chr.lMax
		Add Eax, [Ebx].lpszLine
		Invoke TextOut, [Ebx].hMem, sz.x, 0, Eax, lBytes
	.EndIf
	Pop Eax
	Mov Byte Ptr [Eax], 13
	Ret
rsSetSelectionColor EndP

;===========================================================================;
; Name:		rsStoreUndoText                                                 ;
; Function:	Stores modified text for undo operations                        ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Retuns:   Nothing                                                         ;
;===========================================================================;
rsStoreUndoText Proc Uses Ebx Edi lpEditData:DWord, lpszNewText:LPSTR
	GetEditData lpEditData
	.If [Ebx].lpUndoBuffer != NULL
		Mov Edi, [Ebx].lpszUndoText
		Mov Eax, [Ebx].chrPos.lMin
		.If Eax == [Ebx].chrPos.lMax
			Invoke rsGetStringLength, lpszNewText
			.If Eax == 1
				Mov Eax, lpszNewText
				Invoke rsIsAlphaNumeric, Byte Ptr [Eax], [Ebx].prFindProc
				.If Eax
					.If Byte Ptr [Edi] == 0
						Mov Eax, [Ebx].chrPos.lMin
						Mov [Ebx].lUndoStart, Eax
					.EndIf
					Invoke rsGetStringLength, Edi
					Add Eax, [Ebx].lUndoStart
					.If Eax != [Ebx].chrPos.lMin
						Invoke rsSaveUndoBuffer, lpEditData
						Mov Eax, [Ebx].chrPos.lMin
						Mov [Ebx].lUndoStart, Eax
					.EndIf
					Invoke lstrcat, Edi, lpszNewText
					Invoke lstrlen, Edi
					.If Eax < 254
						Invoke rsClearNextUndoEntry, lpEditData
					.Else
						Invoke rsSaveUndoBuffer, lpEditData
					.EndIf
					Ret
				.EndIf
			.EndIf
		.EndIf
		.If Byte Ptr [Edi] != 0
			Invoke rsSaveUndoBuffer, lpEditData
		.EndIf
		Invoke rsSaveUndoRedoText, lpEditData, lpszNewText
	.EndIf
	Ret
rsStoreUndoText EndP

;===========================================================================;
; Name:		rsUndoAction                                                    ;
; Function:	Performs an undo action (if any)                                ;
;                                                                           ;
; Params:	lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;
rsUndoAction Proc Uses Ebx Ecx Edx Esi lpEditData:DWord
	Local lpch:LPSTR

	GetEditData lpEditData
	.If [Ebx].lpUndoBuffer != NULL
		Mov [Ebx].bSelCol, TRUE
		Mov Esi, [Ebx].lpszUndoText
		.If Byte Ptr [Esi] != 0
			Mov Eax, [Ebx].lUndoStart
			Mov [Ebx].chrPos.lMin, Eax
			Mov [Ebx].chrPos.lMax, Eax
			Invoke rsSaveUndoRedoText, lpEditData, [Ebx].lpszUndoText
			Invoke rsGetStringLength, [Ebx].lpszUndoText
			Add Eax, [Ebx].chrPos.lMax
			Mov [Ebx].chrPos.lMax, Eax
			Mov Byte Ptr [Esi], 0
			Mov [Ebx].lUndoStart, (-1)
			Invoke rsDecrementUndoCount, lpEditData
			Invoke rsReplaceSelection, lpEditData, Esi, (-1)
			Invoke rsSetFirstLineIndex, lpEditData
			Invoke rsMakeSelectionVisible, lpEditData, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
			Mov [Ebx].lLeftOffset, 0 ;?????????
			Invoke rsSetSelection, lpEditData, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
			Invoke rsCheckModified, lpEditData
			Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			Return TRUE
		.EndIf
		Invoke rsDecrementUndoCount, lpEditData
		.If Eax
			Mov Esi, [Ebx].lpUndoBuffer
			Mov Eax, SizeOf DWord
			Mul [Ebx].lUndoCount
			Add Esi, Eax
			.If DWord Ptr [Esi] != NULL
				Push [Ebx].dwEventMask
				Mov [Ebx].dwEventMask, 0
				Invoke GlobalLock, DWord Ptr [Esi]
				Mov lpch, Eax
				Mov Edx, Eax
				Push Edx
				Add lpch, 8
				Mov Eax, DWord Ptr [Edx]
				Mov [Ebx].chrPos.lMin, Eax
				Invoke rsGetStringLength, lpch
				Inc Eax
				Add Eax, lpch
				Push Eax
				Invoke rsGetStringLength, Eax
				Add Eax, DWord Ptr [Edx]
				Mov [Ebx].chrPos.lMax, Eax
				Invoke rsReplaceSelection, lpEditData, lpch, (-1)
				Pop Edx
				.While Byte Ptr [Edx] != 0
					.If Byte Ptr [Edx] == 13
						Mov [Ebx].bChanged, FALSE
						.Break
					.EndIf
					Inc Edx
				.EndW
				Pop Edx
				Invoke rsSetFirstLineIndex, lpEditData
				Invoke rsMakeSelectionVisible, lpEditData, DWord Ptr [Edx], DWord Ptr [Edx + 4]
				Mov Ecx, DWord Ptr [Edx]
				Inc Ecx
				.If Ecx != DWord Ptr [Edx + 4]
					Dec Ecx
				.EndIf
				Invoke rsDiscardBlanks, lpch, Ecx
				Add Eax, Ecx
				Mov [Ebx].lLeftOffset, 0 ;????????
				Pop [Ebx].dwEventMask
				Invoke rsSetSelection, lpEditData, Ecx, DWord Ptr [Edx + 4]
				Invoke GlobalUnlock, DWord Ptr [Esi]
				Invoke rsCheckModified, lpEditData
				Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
				Return TRUE
			.EndIf
		.EndIf
	.EndIf
	Return FALSE
rsUndoAction EndP

rsUpdateControl Proc hWnd:HWND
	Invoke InvalidateRect, hWnd, NULL, FALSE
	Invoke SendMessage, hWnd, WM_PAINT, 0, 0
	Ret
rsUpdateControl EndP

rsUpdateHScrollBar Proc Uses Ebx Edx lpEditData:DWord, bHScroll:BOOL, lSel:LONG
	Local l1:LONG

	GetEditData lpEditData
	.If [Ebx].bHScrollBar
		Invoke rsGetRealColWidth, lpEditData
		Mov l1, Eax
		Add Eax, 2
		Mov Edx, [Ebx].szSize.x
		Add Edx, [Ebx].lTotalHScroll
		.If Eax > Edx
			.If bHScroll
@@:				Inc [Ebx].lLeftOffset
				Mov Eax, [Ebx].lHScroll
				Mov Edx, [Ebx].lLeftOffset
				Mul Edx
				Mov [Ebx].lTotalHScroll, Eax
				Add Eax, [Ebx].szSize.x
				Cmp Eax, l1
				Jle @B
				Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			.EndIf
		.ElseIf [Ebx].lLeftOffset > 0
			Mov Eax, l1
			Sub Eax, [Ebx].lTotalHScroll
			Cmp Eax, 0
			Jg rsUH1
			.If bHScroll
@@:				Dec [Ebx].lLeftOffset
				Mov Eax, [Ebx].lHScroll
				Mov Edx, [Ebx].lLeftOffset
				Mul Edx
				Mov [Ebx].lTotalHScroll, Eax
				Cmp [Ebx].lLeftOffset, 0
				Je @F
				Mov Edx, [Ebx].lLeftOffset
				Dec Edx
				Mul Edx
				Add Eax, [Ebx].szSize.x
				Cmp Eax, l1
				Jg @B
@@:				Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			.EndIf
		.EndIf
rsUH1:	.If [Ebx].lLeftOffset >= 80000000H ;< 0
			Mov [Ebx].lLeftOffset, 0
		.EndIf
		Mov Eax, [Ebx].szFont.x
		Mov Edx, 1024
		Mul Edx
		Xor Edx, Edx
		Div [Ebx].lHScroll
		Mov sci.nMax, Eax
		Mov Eax, [Ebx].lLeftOffset
		Mov sci.nPos, Eax
		Mov sci.nTrackPos, Eax
		Mov Eax, [Ebx].szSize.x
		Xor Edx, Edx
		Div [Ebx].lHScroll
		Mov sci.nPage, Eax
		Invoke SetScrollInfo, [Ebx].hWndEditParent, SB_HORZ, Addr sci, TRUE
	.EndIf
	Ret
rsUpdateHScrollBar EndP

rsUpdateScrollBars Proc Uses Ebx Edx lpEditData:DWord, bHScroll:BOOL
	Invoke rsUpdateHScrollBar, lpEditData, bHScroll, 0
	GetEditData lpEditData
	.If [Ebx].bVScrollBar
		Mov Eax, [Ebx].szSize.y
		Sub Eax, 2
		Xor Edx, Edx
		Div [Ebx].szFont.y
		Dec Eax
		Mov [Ebx].lPageSize, Eax
		Invoke GetScrollInfo, [Ebx].hWndEditParent, SB_VERT, Addr sci
		Mov Eax, [Ebx].lRows
		Dec Eax
		Shl Eax, 2
		Mov sci.nMax, Eax
		Mov Eax, [Ebx].lFirstLine
		Push Eax
		Shl Eax, 2
		Mov sci.nPos, Eax
		Mov Edx, [Ebx].lRows
		Pop Eax
		Sub Edx, Eax
		.If Edx < [Ebx].lPageSize
			.If Eax > 0
				Sub Edx, [Ebx].lPageSize
				Invoke rsLineScroll, lpEditData, 0, Edx
				Mov Eax, [Ebx].lFirstLine
				Shl Eax, 2
				Mov sci.nPos, Eax
			.EndIf
		.EndIf
		Mov Eax, sci.nMax
		Mov Edx, Eax
		Sub Eax, [Ebx].lPageSize
		Sub Edx, Eax
		Shl Edx, 2
		Mov sci.nPage, Edx
		.If Edx >= sci.nMax	; Treure aquestes lnies per a
			Shl Edx, 3 ; fer desaparixer la barra
			Mov sci.nPage, Edx
			Mov sci.nMax, Edx
			Mov sci.nPos, 0

		.EndIf
		Mov Eax, sci.nPos
		Mov sci.nTrackPos, Eax
		Invoke SetScrollInfo, [Ebx].hWndEditParent, SB_VERT, Addr sci, TRUE
	.EndIf
	Ret
rsUpdateScrollBars EndP

;===========================================================================
; RSEdit Parent window procedure
;===========================================================================

wndRSEditParentWndProc Proc Uses Ebx hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local lTemp:LONG, lpch:LPSTR, rc:RECT

	Invoke GetWindowLong, hWnd, GWL_USERDATA
	GetEditData Eax
	.If uMsg == WM_NCCREATE
		Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, SizeOf EDITDATA
		Push Eax
		Invoke SetWindowLong, hWnd, GWL_USERDATA, Eax
		Pop Eax
		GetEditData Eax
		Mov Eax, hWnd
		Mov [Ebx].hWndEditParent, Eax
		Push Ecx
		Invoke GetWindowLong, hWnd, GWL_STYLE
		Mov Ecx, Eax
		And Eax, WS_HSCROLL
		.If Eax
			Mov [Ebx].bHScrollBar, TRUE
		.EndIf
		And Ecx, WS_VSCROLL
		.If Ecx
			Mov [Ebx].bVScrollBar, TRUE
		.EndIf
		Mov [Ebx].lCaretWidth, 1
		Invoke GetParent, hWnd
		Mov [Ebx].hwndParent, Eax
		Return TRUE
	.ElseIf uMsg == WM_CREATE
		Text szStatic, "STATIC"
		Invoke GetClientRect, hWnd, Addr rc
		Invoke CreateWindowEx, 0, Offset szControlClass,
			   NULL, WS_CHILD Or WS_VISIBLE Or WS_CLIPSIBLINGS,
			   0, 0, rc.right, rc.bottom, hWnd, NULL, hInst, NULL

		Invoke CreateWindowEx, 0, Addr szStatic, NULL, WS_CHILD Or \
								WS_VISIBLE Or WS_CLIPSIBLINGS Or SS_NOTIFY, 0, 0,
								0, 0, hWnd, NULL, hInst, NULL
		Mov [Ebx].hwndSelBar, Eax
		Invoke MoveWindow, [Ebx].hwndSelBar, 0, 0, [Ebx].lSelBarWidth, rc.bottom, TRUE
		Mov Eax, rc.right
		Sub Eax, [Ebx].lSelBarWidth
		Invoke MoveWindow, [Ebx].hWnd, [Ebx].lSelBarWidth, 0, Eax, rc.bottom, TRUE
		Invoke GetWindowLong, [Ebx].hwndSelBar, GWL_WNDPROC
		Invoke SetWindowLong, [Ebx].hwndSelBar, GWL_USERDATA, Eax
		Invoke SetWindowLong, [Ebx].hwndSelBar, GWL_WNDPROC, Addr wndSelBarWndProc
		Invoke rsUpdateScrollBars, Ebx, TRUE
		Return 0
	.ElseIf uMsg == WM_CTLCOLORSTATIC
		Mov Eax, [Ebx].hSelBarBrush
		Ret
	.ElseIf uMsg == WM_SETFOCUS
		Invoke SetFocus, [Ebx].hWnd
		Ret
	.ElseIf uMsg == WM_HSCROLL
		Invoke SetFocus, hWnd
		Invoke GetScrollInfo, hWnd, SB_HORZ, Addr sci
		LoWord wParam
		.If Ax == SB_LINELEFT
			.If sci.nPos > 0
				Dec sci.nPos
				Mov Eax, sci.nPos
				Mov [Ebx].lLeftOffset, Eax
			.Else
				Return 0
			.EndIf
		.ElseIf Ax == SB_LINERIGHT
			Mov Eax, sci.nPos
			Add Eax, sci.nPage
			.If Eax <= sci.nMax
				Inc sci.nPos
				Mov Eax, sci.nPos
				Mov [Ebx].lLeftOffset, Eax
			.Else
				Return 0
			.EndIf
		.ElseIf Ax == SB_PAGELEFT
			Mov Eax, [Ebx].lLeftOffset
			Sub Eax, sci.nPage
			.If Eax >= 80000000H ;< 0
				Xor Eax, Eax
				Mov [Ebx].lLeftOffset, Eax
			.Else
				Mov Eax, [Ebx].lLeftOffset
				Sub Eax, sci.nPage
				Mov [Ebx].lLeftOffset, Eax
			.EndIf
			Mov sci.nPos, Eax
			Mov sci.nTrackPos, Eax
		.ElseIf Ax == SB_PAGERIGHT
			Mov Eax, sci.nPage
			Shl Eax, 1
			Add Eax, [Ebx].lLeftOffset
			.If Eax > 1024
				Mov Eax, 1024
				Sub Eax, sci.nPage
				Mov [Ebx].lLeftOffset, Eax
			.Else
				Mov Eax, [Ebx].lLeftOffset
				Add Eax, sci.nPage
				Mov [Ebx].lLeftOffset, Eax
			.EndIf
			Mov sci.nPos, Eax
			Mov sci.nTrackPos, Eax
		.ElseIf Ax == SB_THUMBPOSITION || Ax == SB_THUMBTRACK
			Mov Eax, sci.nTrackPos
			Mov sci.nPos, Eax
			Mov [Ebx].lLeftOffset, Eax
		.EndIf
		Push Edx
		Mov Edx, [Ebx].lHScroll
		Mov Eax, [Ebx].lLeftOffset
		Mul Edx
		Mov [Ebx].lTotalHScroll, Eax
		Pop Edx
		Invoke SetScrollInfo, hWnd, SB_HORZ, Addr sci, TRUE
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		Invoke rsSetCaret, Ebx
		Mov Eax, [Ebx].dwEventMask
		And Eax, EV_HSCROLL
		.If Eax
			Mov Eax, EN_HSCROLL
			Shl Eax, 16
			Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, [Ebx].hWnd
		.EndIf
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		Ret
	.ElseIf uMsg == WM_VSCROLL
		Invoke SetFocus, hWnd
		Invoke GetScrollInfo, hWnd, SB_VERT, Addr sci
		LoWord wParam
		.If Ax == SB_LINEUP
			.If sci.nPos > 0
				Shr sci.nPos, 2
				Dec sci.nPos
				Shl sci.nPos, 2
				Invoke rsLineScroll, Ebx, 0, (-1)
			.Else
				Return 0
			.EndIf
		.ElseIf Ax == SB_LINEDOWN
			Mov Eax, sci.nPos
			Add Eax, sci.nPage
			.If Eax < sci.nMax
				Shr sci.nPos, 2
				Inc sci.nPos
				Shl sci.nPos, 2
				Invoke rsLineScroll, Ebx, 0, 1
			.Else
				Return 0
			.EndIf
		.ElseIf Ax == SB_PAGEUP
			Push Ecx
			Mov Ecx, sci.nPage
			Shr Ecx, 2
			Mov Eax, [Ebx].lFirstLine
			Sub Eax, Ecx
			Pop Ecx
			.If Eax < 0
				Mov Eax, [Ebx].lFirstLine
				Neg Eax
				Invoke rsLineScroll, Ebx, 0, Eax
			.Else
				Mov Eax, sci.nPage
				Shr Eax, 2
				Neg Eax
				Invoke rsLineScroll, Ebx, 0, Eax
			.EndIf
			Mov Eax, [Ebx].lFirstLine
			Shl Eax, 2
			Mov sci.nPos, Eax
			Mov sci.nTrackPos, Eax
		.ElseIf Ax == SB_PAGEDOWN
			Push Ecx
			Mov Ecx, sci.nPage
			Shr Ecx, 2
			Mov Eax, [Ebx].lFirstLine
			Add Eax, Ecx
			Mov Ecx, [Ebx].lRows
			Dec Ecx
			.If Eax > Ecx
				Sub Ecx, [Ebx].lFirstLine
				Mov Eax, sci.nPage
				Shr Eax, 2
				Sub Ecx, Eax
				Invoke rsLineScroll, Ebx, 0, Ecx
			.Else
				Mov Eax, sci.nPage
				Shr Eax, 2
				Invoke rsLineScroll, Ebx, 0, Eax
			.EndIf
			Pop Ecx
			Mov Eax, [Ebx].lFirstLine
			Shl Eax, 2
			Mov sci.nPos, Eax
			Mov sci.nTrackPos, Eax
		.ElseIf Ax == SB_THUMBPOSITION || Ax == SB_THUMBTRACK
			Mov Eax, sci.nTrackPos
			Shr Eax, 2
			Mov sci.nPos, Eax
			Sub Eax, [Ebx].lFirstLine
			Invoke rsLineScroll, Ebx, 0, Eax
			Mov Eax, sci.nPos
			Shl Eax, 2
			Mov sci.nPos, Eax
			Mov sci.nTrackPos, Eax
		.EndIf
		Invoke SetScrollInfo, hWnd, SB_VERT, Addr sci, TRUE
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		Invoke rsSetCaret, Ebx
		Mov Eax, [Ebx].dwEventMask
		And Eax, EV_VSCROLL
		.If Eax
			Mov Eax, EN_VSCROLL
			Shl Eax, 16
			Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, [Ebx].hWnd
		.EndIf
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		Ret
	.ElseIf uMsg == WM_GETFONT
		Mov Eax, [Ebx].hFont
		Ret
	.ElseIf uMsg == WM_GETTEXT
		Mov Eax, [Ebx].lTextLength
		Inc Eax
		.If wParam > Eax
			Mov wParam, Eax
		.EndIf
		Invoke lstrcpyn, lParam, [Ebx].lpszText, wParam
		Return wParam
	.ElseIf uMsg == WM_GETTEXTLENGTH
		Mov Eax, [Ebx].lTextLength
		Ret
	.ElseIf uMsg == WM_SETFONT
		Text szCharSize, "W"
		Mov Eax, wParam
		Mov [Ebx].hFont, Eax
		Invoke SelectObject, [Ebx].hMem, [Ebx].hFont
		.If Eax != [Ebx].hFont
			Invoke DeleteObject, Eax
		.EndIf
		Push Edx
		Text szScroll, "AAAAAAAAAAAA"
		Invoke GetTextExtentPoint32, [Ebx].hMem, Addr szScroll, 12, Addr [Ebx].szFont
		Mov Edx, [Ebx].szFont.x
		Mov [Ebx].lHScroll, Edx
		Mov Eax, [Ebx].lLeftOffset
		Mul Edx
		Mov [Ebx].lTotalHScroll, Eax
		Invoke GetTextExtentPoint32, [Ebx].hMem, Addr szCharSize, 1, Addr [Ebx].szFont
		Mov Eax, 1026
		Mul [Ebx].szFont.x
		Add Eax, [Ebx].lHScroll
		Push Esi
		Invoke CreateCompatibleBitmap, [Ebx].hMem, Eax, [Ebx].szFont.y
		Mov Esi, Eax
		Invoke SelectObject, [Ebx].hMem, Eax
		.If Eax != Esi
			Invoke DeleteObject, Eax
		.EndIf
		Mov [Ebx].hBitmap, Esi
		Pop Esi
		Invoke SetBkMode, [Ebx].hMem, TRANSPARENT
		Invoke SetTextColor, [Ebx].hMem, [Ebx].crRealTextColor
		Pop Edx
		Mov Eax, [Ebx].szFont.x
		Mov [Ebx].lSelBarWidth, Eax
		Invoke SetWindowPos, [Ebx].hwndSelBar, 0, 0, 0, [Ebx].lSelBarWidth, [Ebx].szSize.y, SWP_NOMOVE Or SWP_FRAMECHANGED
		Invoke GetClientRect, hWnd, Addr rc
		Push Ecx
		Mov Ecx, rc.right
		Mov Eax, rc.bottom
		MakeLong Cx, Ax
		Pop Ecx
		Invoke SendMessage, hWnd, WM_SIZE, 0, Eax
		.If lParam
			Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		.EndIf
	.ElseIf uMsg == WM_SETTEXT
		Invoke rsGetStringLength, lParam
		.If [Ebx].lBufferLength <= Eax
			Add Eax, 1023
			Mov [Ebx].lBufferLength, Eax
			Invoke VirtualFree, [Ebx].lpszMemPtr, 0, MEM_RELEASE
			Mov Eax, [Ebx].lBufferLength
			Inc Eax
			Invoke VirtualAlloc, 0, Eax, MEM_COMMIT, PAGE_READWRITE
			Mov [Ebx].lpszMemPtr, Eax
			Mov Byte Ptr [Eax], 10
			Inc Eax
			Mov [Ebx].lpszText, Eax
		.EndIf
		Invoke rsCopyString, [Ebx].lpszText, lParam
		Mov [Ebx].lTextLength, Eax
		Invoke rsInitEditor, Ebx, [Ebx].lTextLength
		Invoke rsUpdateScrollBars, Ebx, TRUE
		Invoke rsUpdateControl, [Ebx].hWnd
		Invoke rsSetCaret, Ebx
		Return 0
	.ElseIf uMsg == WM_CUT || uMsg == WM_COPY
		Mov Eax, [Ebx].chrPos.lMax
		.If Eax > [Ebx].chrPos.lMin
			Invoke OpenClipboard, hWnd
			Invoke EmptyClipboard
			Mov Eax, [Ebx].chrPos.lMax
			Sub Eax, [Ebx].chrPos.lMin
			Inc Eax
			Invoke GlobalAlloc, GMEM_MOVEABLE Or GMEM_DDESHARE Or GMEM_ZEROINIT, Eax
			Mov lTemp, Eax
			Invoke GlobalLock, lTemp
			Mov lpch, Eax
			Invoke SendMessage, hWnd, RSM_GETSELTEXT, 0, lpch
			Invoke GlobalUnlock, lTemp
			Invoke SetClipboardData, CF_TEXT, lTemp
			Invoke CloseClipboard
			.If uMsg == WM_CUT
				Lea Eax, szChar
				Mov Word Ptr [Eax], 0
				Invoke rsReplaceSelection, Ebx, Addr szChar, VK_DELETE
				Invoke rsSetFirstLineIndex, Ebx
			.EndIf
		.EndIf
		Return 0
	.ElseIf uMsg == WM_PASTE
		Invoke OpenClipboard, hWnd
		.If Eax
			Invoke GetClipboardData, CF_TEXT
			Mov lTemp, Eax
			.If lTemp != NULL
				Invoke GlobalLock, lTemp
				Mov lpch, Eax
				Invoke rsReplaceSelection, Ebx, lpch, 0
				Invoke rsSetFirstLineIndex, Ebx
				Invoke GlobalUnlock, lTemp
			.EndIf
			Invoke CloseClipboard
		.EndIf
		Return 0
	.ElseIf uMsg == WM_UNDO
		Invoke SendMessage, hWnd, RSM_CANUNDO, 0, 0
		.If Eax
			Invoke rsUndoAction, Ebx
		.EndIf
		Ret
	.ElseIf uMsg == RSM_CANPASTE
		Invoke IsClipboardFormatAvailable, CF_TEXT
		Ret
	.ElseIf uMsg == RSM_CANREDO
		.If [Ebx].lpUndoBuffer == NULL
			Mov Eax, FALSE
		.Else
			Push Edx
			Mov Eax, SizeOf DWord
			Mul [Ebx].lUndoCount
			Add Eax, [Ebx].lpUndoBuffer
			.If DWord Ptr [Eax] != NULL
				Mov Eax, TRUE
			.Else
				Mov Eax, FALSE
			.EndIf
			Pop Edx
		.EndIf
		Ret
	.ElseIf uMsg == RSM_CANUNDO
		.If [Ebx].lpUndoBuffer == NULL
			Mov Eax, FALSE
		.Else
			Push Edx
			Mov Edx, SizeOf DWord
			Mov Eax, [Ebx].lUndoCount
			.If Eax == 0
				Mov Eax, [Ebx].lUndoLimit
			.EndIf
			Dec Eax
			Mul Edx
			Add Eax, [Ebx].lpUndoBuffer
			Mov Edx, [Ebx].lpszUndoText
			.If DWord Ptr [Eax] != NULL || Byte Ptr [Edx] != 0
				Mov Eax, TRUE
			.Else
				Mov Eax, FALSE
			.EndIf
			Pop Edx
		.EndIf
		Ret
	.ElseIf uMsg == RSM_CLEARUNDOBUFFER
		Invoke rsClearUndoBuffer, Ebx
		Return 0
	.ElseIf uMsg == RSM_FINDWORD
		Mov Eax, [Ebx].lTextLength
		.If lParam > Eax || lParam >= 80000000H ;< 0
			Return (-1)
		.ElseIf wParam != RSC_PREV && wParam != RSC_NEXT
			Return (-1)
		.ElseIf wParam == RSC_PREV
			Invoke rsFindPrevWord, Ebx, lParam
		.ElseIf wParam == RSC_NEXT
			Invoke rsFindNextWord, Ebx, lParam
		.EndIf
		Ret
	.ElseIf uMsg == RSM_FINDTEXT
		Invoke rsFindText, Ebx, wParam, lParam
		Ret
	.ElseIf uMsg == RSM_GETBACKCOLOR
		Mov Eax, [Ebx].crRealBackColor
		Ret
	.ElseIf uMsg == RSM_GETEVENTMASK
		Mov Eax, [Ebx].dwEventMask
		Ret
	.ElseIf uMsg == RSM_GETFIRSTVISIBLELINE
		Mov Eax, [Ebx].lFirstLine
		Ret
	.ElseIf uMsg == RSM_GETHANDLE
		Mov Eax, [Ebx].lpszText
		Ret
	.ElseIf uMsg == RSM_GETHIDESELECTION
		Mov Eax, [Ebx].bHideSelection
		Ret
	.ElseIf uMsg == RSM_GETLINE
		Mov Eax, [Ebx].lRows
		.If wParam >= Eax
			Mov Eax, lParam
			Mov Byte Ptr [Eax], 0
			Mov lTemp, 0
		.Else
			Invoke rsGetLineIndex, Ebx, wParam
			Mov lTemp, Eax
			Add Eax, [Ebx].lpszText
			Mov lpch, Eax
			Invoke rsGetNextLineIndex, Ebx, lTemp
			Dec Eax
			Sub Eax, lTemp
			Mov lTemp, Eax
			Cmp Eax, 0
			Jge @F
			Xor Eax, Eax
			Ret
@@:			Inc lTemp
			Invoke lstrcpyn, lParam, lpch, lTemp
			Dec lTemp
		.EndIf
		Return lTemp
	.ElseIf uMsg == RSM_GETLINECOUNT
		Mov Eax, [Ebx].lRows
		Ret
	.ElseIf uMsg == RSM_GETLINEFROMCHAR
		Mov Eax, [Ebx].lTextLength
		Cmp lParam, Eax
		Jle @F
		Mov Eax, (-1)
		Ret
@@:		Cmp lParam, 0
		Jge rsEdit2
		Mov Eax, (-1)
		Ret
rsEdit2:
		Invoke rsGetLineFromChar, Ebx, wParam, FALSE
		Ret
	.ElseIf uMsg == RSM_GETLINEINDEX
		Mov Eax, [Ebx].lRows
		.If wParam >= Eax || wParam >= 80000000H ;< 0
			Return (-1)
		.EndIf
		Invoke rsGetLineIndex, Ebx, wParam
		Ret
	.ElseIf uMsg == RSM_GETLINELENGTH
		.If lParam == (-1)
			Invoke rsGetLineIndex, Ebx, wParam
			Mov lParam, Eax
		.EndIf
		Invoke rsGetLineLength, Ebx, lParam
		Ret
	.ElseIf uMsg == RSM_GETMODIFY
		Mov Eax, [Ebx].bModified
		Ret
	.ElseIf uMsg == RSM_GETPOSITION
		Push Edx
		.If wParam != NULL
			Mov Edx, wParam
			Mov Eax, [Ebx].lRealCol
			Mov DWord Ptr [Edx], Eax
		.EndIf
		.If lParam != NULL
			Mov Edx, lParam
			Mov Eax, [Ebx].ptPos.y
			Mov DWord Ptr [Edx], Eax
		.EndIf
		Pop Edx
		Return 0
	.ElseIf uMsg == RSM_GETSELBACKCOLOR
		Mov Eax, [Ebx].crRealBackSelect
		Ret
	.ElseIf uMsg == RSM_GETSELBARCOLOR
		Mov Eax, [Ebx].crSelBarColor
		Ret
	.ElseIf uMsg == RSM_GETSELBARWIDTH
		Mov Eax, [Ebx].lSelBarWidth
		Ret
	.ElseIf uMsg == RSM_GETSELECTION
		Push Edx
		.If wParam != NULL
			Mov Edx, wParam
			Mov Eax, [Ebx].chrPos.lMin
			Mov DWord Ptr [Edx], Eax
		.EndIf
		.If lParam != NULL
			Mov Edx, lParam
			Mov Eax, [Ebx].chrPos.lMax
			Mov DWord Ptr [Edx], Eax
		.EndIf
		Pop Edx
		Return 0
	.ElseIf uMsg == RSM_GETSELTEXT
		Mov Eax, [Ebx].chrPos.lMax
		Sub Eax, [Ebx].chrPos.lMin
		Inc Eax
		Mov lTemp, Eax
		Mov Eax, [Ebx].lpszText
		Add Eax, [Ebx].chrPos.lMin
		Invoke lstrcpyn, lParam, Eax, lTemp
		Dec lTemp
		Return lTemp
	.ElseIf uMsg == RSM_GETSELTEXTCOLOR
		Mov Eax, [Ebx].crRealTextSelect
		Ret
	.ElseIf uMsg == RSM_GETTEXTCOLOR
		Mov Eax, [Ebx].crRealTextColor
		Ret
	.ElseIf uMsg == RSM_LINESCROLL
		Invoke rsLineScroll, Ebx, wParam, lParam
		Invoke rsSetCaret, Ebx
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		Invoke rsUpdateScrollBars, Ebx, FALSE
		Return 0
	.ElseIf uMsg == RSM_REPLACESEL
		Invoke rsReplaceSelection, Ebx, lParam, 0
		Return 0
	.ElseIf uMsg == RSM_REDO
		Invoke SendMessage, hWnd, RSM_CANREDO, 0, 0
		.If Eax
			Invoke rsRedoAction, Ebx
		.EndIf
		Ret
	.ElseIf uMsg == RSM_SETAUTOINDENT
		Mov Eax, wParam
		Mov [Ebx].bAutoIndent, Eax
		Return 0
	.ElseIf uMsg == RSM_SETBACKCOLOR
		Mov Eax, lParam
		Mov [Ebx].crRealBackColor, Eax
		Invoke rsChangeControlColors, Ebx, 1
		Return 0
	.ElseIf uMsg == RSM_SETCARETWIDTH
		Mov Eax, lParam
		Cmp Eax, 0
		Jg @F
		Ret
@@:		Cmp Eax, 5
		Jl @F
		Ret
@@:		Mov [Ebx].lCaretWidth, Eax
		Invoke rsDisplayCursor, Ebx
		Return 0
	.ElseIf uMsg == RSM_SETEVENTMASK
		Mov Eax, lParam
		Mov [Ebx].dwEventMask, Eax
		Invoke rsUpdateControl, [Ebx].hWnd
		Return 0
	.ElseIf uMsg == RSM_SETFINDPROC
		Mov Eax, lParam
		Mov [Ebx].prFindProc, Eax
		Invoke rsUpdateControl, [Ebx].hWnd
		Lea Eax, rsFindHook
		Ret
	.ElseIf uMsg == RSM_SETHIDESELECTION
		Mov Eax, wParam
		Mov [Ebx].bHideSelection, Eax
		Invoke rsUpdateControl, [Ebx].hWnd
		Return 0
	.ElseIf uMsg == RSM_SETHSCROLLBAR
		Invoke GetWindowLong, hWnd, GWL_STYLE
		.If wParam
			Or Eax, WS_HSCROLL
			Mov [Ebx].bHScrollBar, TRUE
		.Else
			And Eax, (Not WS_HSCROLL)
			Mov [Ebx].bHScrollBar, FALSE
		.EndIf
		Invoke SetWindowLong, hWnd, GWL_STYLE, Eax
		Invoke SetWindowPos, hWnd, 0, 0, 0, 0, 0, SWP_NOZORDER Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED
		Invoke rsUpdateScrollBars, Ebx, TRUE
		Invoke InvalidateRect, hWnd, NULL, FALSE
		Ret
	.ElseIf uMsg == RSM_SETMODIFY
		Mov Eax, wParam
		Mov [Ebx].bModified, Eax
		Mov Eax, [Ebx].lUndoCount
		Mov [Ebx].lStartModified, Eax
		Return 0
	.ElseIf uMsg == RSM_SETPAINTPROC
		Mov Eax, lParam
		Mov [Ebx].prPaintProc, Eax
		Invoke rsUpdateControl, [Ebx].hWnd
		Lea Eax, rsPaintControl
		Ret
	.ElseIf uMsg == RSM_SETREADONLY
		Mov Eax, wParam
		Mov [Ebx].bReadOnly, Eax
		.If wParam
			Invoke DestroyCaret
		.Else
			Invoke rsDisplayCursor, Ebx
		.EndIf
		Invoke rsUpdateControl, [Ebx].hWnd
		Return 0
	.ElseIf uMsg == RSM_SETSELBACKCOLOR
		Mov Eax, lParam
		Mov [Ebx].crRealBackSelect, Eax
		Invoke rsChangeControlColors, Ebx, 8
		Return 0
	.ElseIf uMsg == RSM_SETSELBARCOLOR
		Mov Eax, lParam
		Mov [Ebx].crSelBarColor, Eax
		Invoke rsChangeControlColors, Ebx, 2
		Return 0
	.ElseIf uMsg == RSM_SETSELBARWIDTH
		Mov Eax, lParam
		Cmp Eax, 0
		Jge @F
		Return (-1)
@@:		Mov [Ebx].lSelBarWidth, Eax
		Invoke GetClientRect, hWnd, Addr rc
		Push Ecx
		Mov Ecx, rc.right
		Mov Eax, rc.bottom
		MakeLong Cx, Ax
		Pop Ecx
		Invoke SendMessage, hWnd, WM_SIZE, 0, Eax
		Invoke InvalidateRect, [Ebx].hwndSelBar, NULL, TRUE
		Invoke rsUpdateControl, [Ebx].hWnd
		Return 0
	.ElseIf uMsg == RSM_SETSELECTION
		Push Ecx
		Mov Ecx, [Ebx].lTextLength
		.If lParam >= 80000000H || lParam > Ecx ; < 0
			Mov Eax, wParam
			Mov lParam, Eax
		.EndIf
		.If wParam >= 80000000H || wParam > Ecx ; < 0
			Mov Eax, lParam
			Mov wParam, Eax
			.If lParam >= 80000000H || lParam > Ecx ; < 0
				Pop Ecx
				Ret
			.EndIf
		.EndIf
		Pop Ecx
		Mov [Ebx].bSelCol, TRUE
		Mov Eax, [Ebx].lpszText
		Push Eax
		Add Eax, wParam
		.If Byte Ptr [Eax] == 10
			Inc wParam
		.EndIf
		Pop Eax
		Add Eax, lParam
		.If Byte Ptr [Eax] == 10
			Inc lParam
		.EndIf
		Invoke rsSetSelection, Ebx, wParam, lParam
		Push Ecx
		Mov Eax, [Ebx].chrPos.lMax
		Sub Eax, [Ebx].chrPos.lMin
		Mov Ecx, [Ebx].ptPos.x
		Sub Ecx, Eax
		.If Ecx < [Ebx].lLeftOffset
			Mov Eax, lParam
			Sub Eax, wParam
			Invoke rsUpdateHScrollBar, Ebx, TRUE, Eax
		.EndIf
		Pop Ecx
		Return 0
	.ElseIf uMsg == RSM_SETSELTEXTCOLOR
		Mov Eax, lParam
		Mov [Ebx].crRealTextSelect, Eax
		Invoke rsChangeControlColors, Ebx, 16
		Return 0
	.ElseIf uMsg == RSM_SETTABSTOPS
		.If wParam > 0 && wParam <= 16
			Mov Eax, wParam
			Mov [Ebx].lTabStops, Eax
			Invoke rsUpdateControl, [Ebx].hWnd
		.EndIf
		Return 0
	.ElseIf uMsg == RSM_SETTEXTCOLOR
		Mov Eax, lParam
		Mov [Ebx].crRealTextColor, Eax
		Invoke rsChangeControlColors, Ebx, 4
		Return 0
	.ElseIf uMsg == RSM_SETUNDOLIMIT
		Invoke rsClearUndoBuffer, Ebx
		.If [Ebx].lpUndoBuffer != NULL
			Invoke GlobalFree, [Ebx].lpUndoBuffer
		.EndIf
		Mov [Ebx].lpUndoBuffer, NULL
		Mov Eax, wParam
		And Eax, 7FFFFFFFH
		Mov [Ebx].lUndoLimit, Eax
		.If Eax > 0
			Push Edx
			Mov Eax, SizeOf DWord
			Mul [Ebx].lUndoLimit
			Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, Eax
			Mov [Ebx].lpUndoBuffer, Eax
			Pop Edx
		.EndIf
		Mov Eax, [Ebx].lpszUndoText
		Mov Byte Ptr [Eax], 0
		Return 0
	.ElseIf uMsg == RSM_SETVSCROLLBAR
		Invoke GetWindowLong, hWnd, GWL_STYLE
		.If wParam
			Or Eax, WS_VSCROLL
			Mov [Ebx].bVScrollBar, TRUE
		.Else
			And Eax, (Not WS_VSCROLL)
			Mov [Ebx].bVScrollBar, FALSE
		.EndIf
		Invoke SetWindowLong, hWnd, GWL_STYLE, Eax
		Invoke SetWindowPos, hWnd, 0, 0, 0, 0, 0, SWP_NOZORDER Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED
		Invoke rsUpdateScrollBars, Ebx, TRUE
		Invoke InvalidateRect, hWnd, NULL, FALSE
		Ret
	.ElseIf uMsg == WM_SYSCOLORCHANGE
		Invoke rsChangeControlColors, Ebx, 31
		Return 0
	.ElseIf uMsg == WM_SIZE
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		LoWord lParam
		Mov rc.right, Eax
		HiWord lParam
		Mov rc.bottom, Eax
		.If [Ebx].lSelBarWidth > 0
			Invoke MoveWindow, [Ebx].hwndSelBar, 0, 0, [Ebx].lSelBarWidth, rc.bottom, TRUE
		.EndIf
		Mov Eax, [Ebx].lSelBarWidth
		Sub rc.right, Eax
		Invoke MoveWindow, [Ebx].hWnd, [Ebx].lSelBarWidth, 0, rc.right, rc.bottom, TRUE
		Return 0
	.ElseIf uMsg == WM_DESTROY
		Invoke DestroyWindow, [Ebx].hwndSelBar
		Invoke DestroyWindow, [Ebx].hWnd
	.ElseIf uMsg == WM_NCDESTROY
		Invoke GlobalFree, Ebx
	.EndIf
	Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	Ret
	Assume Ebx:Nothing
wndRSEditParentWndProc EndP

;===========================================================================
; RSEdit window procedure
;===========================================================================

wndRSEditWndProc Proc Uses Ebx hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local bCtrl:BOOL, bShift:BOOL, bAlt:BOOL
	Local lTemp:LONG, rc:RECT
	Local hdc:HDC, chr:RSSCHARSEL

	Invoke GetWindowLong, hWnd, GWL_USERDATA
	GetEditData Eax
	.If uMsg == WM_NCCREATE
		Invoke GetParent, hWnd
		Invoke GetWindowLong, Eax, GWL_USERDATA
		Mov Ebx, Eax
		Invoke SetWindowLong, hWnd, GWL_USERDATA, Eax
		Mov Eax, hWnd
		Mov [Ebx].hWnd, Eax
		Mov [Ebx].lBufferLength, 4092
		Invoke VirtualAlloc, 0, 4096, MEM_COMMIT, PAGE_READWRITE
		Mov [Ebx].lpszMemPtr, Eax
		Mov Byte Ptr [Eax], 10
		Inc Eax
		Mov [Ebx].lpszText, Eax
		Mov Eax, Offset rsFindHook
		Mov [Ebx].prFindProc, Eax
		Invoke rsInitEditor, Ebx, (-1)
		Return TRUE
	.ElseIf uMsg == WM_CREATE
		Text szFontName, "MS Sans Serif"
		Text szCharW, "W"
		Invoke GetClientRect, hWnd, Addr rc
		Invoke GetDC, hWnd
		Mov hdc, Eax
		GetEditData Ebx
		Invoke CreateCompatibleDC, hdc
		Mov [Ebx].hMem, Eax
		Invoke CreateCompatibleBitmap, hdc, rc.right, rc.bottom
		Mov [Ebx].hBitmap, Eax
		Invoke SelectObject, [Ebx].hMem, [Ebx].hBitmap
		Invoke DeleteObject, Eax
		Invoke ReleaseDC, hWnd, hdc
		Push Edx
		Mov lTemp, 10
		Invoke GetDeviceCaps, [Ebx].hMem, LOGPIXELSY
		Mul lTemp
		Mov lTemp, 72
		Xor Edx, Edx
		Div lTemp
		Mov lTemp, Eax
		Neg lTemp
		Pop Edx
		Invoke CreateFont, lTemp, 0, 0, 0, 400, FALSE, FALSE, FALSE, ANSI_CHARSET, 0, 0, 0, 0, Addr szFontName
		Mov [Ebx].hFont, Eax
		Invoke SelectObject, [Ebx].hMem, Eax
		.If Eax != [Ebx].hFont
			Invoke DeleteObject, Eax
		.EndIf
		Invoke GetTextExtentPoint32, [Ebx].hMem, Addr szCharW, 1, Addr [Ebx].szFont
		Mov [Ebx].lTabStops, 4
		Mov [Ebx].bInsert, TRUE
		Mov [Ebx].crRealBackColor, (80000000H Or COLOR_WINDOW)
		Mov [Ebx].crRealTextColor, (80000000H Or COLOR_WINDOWTEXT)
		Mov [Ebx].crSelBarColor, 00E0E0E0H
		Mov [Ebx].crRealBackSelect, (80000000H Or COLOR_HIGHLIGHT)
		Mov [Ebx].crRealTextSelect, (80000000H Or COLOR_HIGHLIGHTTEXT)
		Invoke SendMessage, [Ebx].hWndEditParent, WM_SETFONT, [Ebx].hFont, TRUE
		Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, 1025
		Mov [Ebx].lpszLine, Eax
		Mov [Ebx].dwEventMask, (EV_CHANGE Or EV_SELCHANGE Or EV_HSCROLL Or EV_VSCROLL Or EV_UPDATE)
		Mov [Ebx].prPaintProc, NULL
		Mov [Ebx].lStartModified, 0
		Mov [Ebx].lUndoCount, 0
		Mov [Ebx].lUndoLimit, 100
		Mov [Ebx].lUndoStart, (-1)
		Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, 256
		Mov [Ebx].lpszUndoText, Eax
		Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, 404
		Mov [Ebx].lpUndoBuffer, Eax
		Invoke rsChangeControlColors, Ebx, 31
		Mov sci.cbSize, SizeOf SCROLLINFO
		Mov sci.fMask, SIF_ALL
		Return 0
	.ElseIf uMsg == WM_ERASEBKGND
		Return TRUE
	.ElseIf uMsg == WM_PAINT
		Invoke rsPaintControl, Ebx
		Return 0
	.ElseIf uMsg == WM_KILLFOCUS
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		Invoke DestroyCaret
		Mov [Ebx].bCaret, FALSE
		Mov Eax, EN_KILLFOCUS
		Shl Eax, 16
		Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, hWnd
		Return 0
	.ElseIf uMsg == WM_SETFOCUS
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		Invoke rsDisplayCursor, Ebx
		Mov Eax, EN_SETFOCUS
		Shl Eax, 16
		Invoke SendMessage, [Ebx].hwndParent, WM_COMMAND, Eax, hWnd
		Return 0
	.ElseIf uMsg == WM_KEYDOWN
		Invoke GetKeyState, VK_CONTROL
		And Eax, 00008000H
		Mov bCtrl, Eax
		Invoke GetKeyState, VK_SHIFT
		And Eax, 00008000H
		Mov bShift, Eax
		Invoke GetKeyState, VK_MENU
		And Eax, 00008000H
		Mov bAlt, Eax
		Mov Eax, [Ebx].chrPos.lMin
		Mov chr.lMin, Eax
		Mov Eax, [Ebx].chrPos.lMax
		Mov chr.lMax, Eax
		.If wParam == 67 ;Ctrl+C
			.If bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, WM_COPY, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == 86 ;Ctrl+V
			.If bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, WM_PASTE, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == 88 ;Ctrl+X
			.If bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, WM_CUT, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == 89 ;Ctrl+Y
			.If bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, RSM_REDO, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == 90 ;Ctrl+Z
			.If bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, WM_UNDO, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == VK_ESCAPE
			Mov Eax, [Ebx].chrPos.lMax
			.If Eax > [Ebx].chrPos.lMin
				Mov Eax, [Ebx].chrSel.lMax
				Mov [Ebx].chrPos.lMin, Eax
				Mov [Ebx].chrPos.lMax, Eax
				Invoke InvalidateRect, hWnd, NULL, FALSE
				Invoke rsSetCaret, Ebx
			.EndIf
			Return 0
		.ElseIf wParam == VK_INSERT
			.If !bCtrl && !bShift && !bAlt
				Mov Eax, [Ebx].bInsert
				Neg Eax
				Inc Eax
				Mov [Ebx].bInsert, Eax
				Return 0
			.ElseIf bCtrl && !bShift
				Invoke SendMessage, [Ebx].hWndEditParent, WM_COPY, 0, 0
				Return 0
			.ElseIf bShift && !bCtrl
				Invoke SendMessage, [Ebx].hWndEditParent, WM_PASTE, 0, 0
				Return 0
			.EndIf
		.ElseIf wParam == VK_SHIFT || wParam == VK_CONTROL || wParam == VK_MENU && !bCtrl
			Return 0
		.ElseIf wParam == VK_DELETE
			.If !bCtrl && !bAlt
				Mov Eax, [Ebx].lTextLength
				.If [Ebx].chrPos.lMin < Eax
					Lea Eax, szChar
					Mov Word Ptr [Eax], 0
					Mov Eax, [Ebx].chrPos.lMax
					Sub Eax, [Ebx].chrPos.lMin
					Mov lTemp, Eax
					.If lTemp == 0
						Inc [Ebx].chrPos.lMax
						Mov Eax, [Ebx].lpszText
						Add Eax, [Ebx].chrPos.lMin
						.If Byte Ptr [Eax] == 13
							.If [Ebx].lRealCol >= 1023
								Dec [Ebx].chrPos.lMax
								Invoke MessageBeep, 0
								Return 0
							.EndIf
							Inc [Ebx].chrPos.lMax
						.EndIf
					.EndIf
					Invoke rsReplaceSelection, Ebx, Addr szChar, wParam
					.If lTemp > 0
						Invoke rsSetFirstLineIndex, Ebx
						Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
					.EndIf
				.EndIf
			.EndIf
			Return 0
		.ElseIf wParam == VK_HOME
			.If bCtrl
				.If bShift
					.If [Ebx].chrPos.lMin > 0
						Mov [Ebx].chrPos.lMax, 0
						Mov Eax, [Ebx].chrSel.lMin
						Mov [Ebx].chrPos.lMin, Eax
					.EndIf
				.Else
					Mov [Ebx].chrPos.lMin, 0
					Mov [Ebx].chrPos.lMax, 0
				.EndIf
			.ElseIf bShift
				Invoke rsFindFirstChar, Ebx
				Add Eax, [Ebx].lLineIndex
				Mov lTemp, Eax
				Mov Eax, [Ebx].chrSel.lMax
				.If [Ebx].chrSel.lMin == Eax
					Mov Eax, lTemp
					Mov [Ebx].chrPos.lMax, Eax
				.Else
					Mov Eax, [Ebx].chrSel.lMin
					Mov [Ebx].chrPos.lMin, Eax
					Mov Eax, lTemp
					Mov [Ebx].chrPos.lMax, Eax
				.EndIf
			.Else
				Invoke rsFindFirstChar, Ebx
				Add Eax, [Ebx].lLineIndex
				Mov [Ebx].chrPos.lMin, Eax
				Mov [Ebx].chrPos.lMax, Eax
			.EndIf
			Mov [Ebx].bSelCol, TRUE
		.ElseIf wParam == VK_END
			Mov Eax, [Ebx].lTextLength
			Mov lTemp, Eax
			.If bCtrl
				.If bShift
					Mov Eax, [Ebx].chrSel.lMax
					.If Eax < [Ebx].chrSel.lMin
						Mov Eax, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMin, Eax
						Mov Eax, lTemp
						Mov [Ebx].chrPos.lMax, Eax
					.Else
						Mov Eax, lTemp
						Mov [Ebx].chrPos.lMax, Eax
					.EndIf
				.Else
					Mov Eax, lTemp
					Mov [Ebx].chrPos.lMax, Eax
					Mov [Ebx].chrPos.lMin, Eax
				.EndIf
			.ElseIf bShift
				Mov Eax, [Ebx].chrSel.lMax
				.If Eax < [Ebx].chrSel.lMin
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].chrPos.lMin, Eax
					Mov Eax, [Ebx].lLineIndex
					Add Eax, [Ebx].lCols
					Mov [Ebx].chrPos.lMax, Eax
				.Else
					Mov Eax, [Ebx].lLineIndex
					Add Eax, [Ebx].lCols
					Mov [Ebx].chrPos.lMax, Eax
				.EndIf
			.Else
				Mov Eax, [Ebx].lLineIndex
				Add Eax, [Ebx].lCols
				Mov [Ebx].chrPos.lMin, Eax
				Mov [Ebx].chrPos.lMax, Eax
			.EndIf
			Mov [Ebx].bSelCol, TRUE
		.ElseIf wParam == VK_LEFT
			.If bCtrl
				Invoke rsFindPrevWord, Ebx, [Ebx].chrPos.lMin
				Mov lTemp, Eax
				.If bShift
					Mov Eax, [Ebx].chrSel.lMin
					.If Eax == [Ebx].chrSel.lMax
						.If [Ebx].chrPos.lMin > 0
							Mov Eax, lTemp
							Mov [Ebx].chrPos.lMax, Eax
						.EndIf
					.ElseIf [Ebx].chrSel.lMax > Eax
						Invoke rsFindPrevWord, Ebx, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMax, Eax
					.Else
						Mov Eax, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMin, Eax
						Mov Eax, lTemp
						Mov [Ebx].chrPos.lMax, Eax
					.EndIf
				.Else
					Mov Eax, [Ebx].chrSel.lMax
					.If Eax == [Ebx].chrSel.lMin
						Mov Eax, lTemp
						Mov [Ebx].chrPos.lMin, Eax
						Mov [Ebx].chrPos.lMax, Eax
					.Else
						Mov Eax, [Ebx].chrPos.lMin
						Mov [Ebx].chrPos.lMax, Eax
					.EndIf
				.EndIf
			.ElseIf bShift
				Mov Eax, [Ebx].chrSel.lMin
				.If Eax == [Ebx].chrSel.lMax
					.If [Ebx].chrPos.lMin > 0
						Mov Eax, [Ebx].chrPos.lMin
						Dec Eax
						Mov [Ebx].chrPos.lMax, Eax
					.EndIf
				.ElseIf [Ebx].chrSel.lMax > Eax
					.If [Ebx].chrPos.lMax > 0
						Dec [Ebx].chrPos.lMax
					.EndIf
				.Else
					.If [Ebx].chrPos.lMin > 0
						Mov Eax, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMin, Eax
						Mov Eax, [Ebx].chrSel.lMax
						Mov [Ebx].chrPos.lMax, Eax
						.If [Ebx].chrPos.lMax > 0
							Dec [Ebx].chrPos.lMax
						.EndIf
					.EndIf
				.EndIf
			.Else
				Mov Eax, [Ebx].chrSel.lMax
				.If [Ebx].chrSel.lMin == Eax
					.If [Ebx].chrPos.lMin > 0
						Dec [Ebx].chrPos.lMin
					.EndIf
				.EndIf
				Mov Eax, [Ebx].chrPos.lMin
				Mov [Ebx].chrPos.lMax, Eax
			.EndIf
			Mov Eax, [Ebx].lpszText
			Add Eax, [Ebx].chrPos.lMax
			.If Byte Ptr [Eax] == 10
				Mov Eax, [Ebx].chrPos.lMin
				.If Eax == [Ebx].chrPos.lMax
					Dec [Ebx].chrPos.lMin
				.EndIf
				Dec [Ebx].chrPos.lMax
			.EndIf
			Mov [Ebx].bSelCol, TRUE
		.ElseIf wParam == VK_RIGHT
			Mov Eax, [Ebx].lTextLength
			Mov lTemp, Eax
			.If bCtrl
				.If bShift
					Mov Eax, [Ebx].chrSel.lMax
					.If [Ebx].chrSel.lMin == Eax
						Mov Eax, [Ebx].chrPos.lMax
						.If Eax < lTemp
							Invoke rsFindNextWord, Ebx, [Ebx].chrPos.lMin
							Mov [Ebx].chrPos.lMax, Eax
						.EndIf
					.ElseIf Eax > [Ebx].chrSel.lMin
						Invoke rsFindNextWord, Ebx, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMax, Eax
					.Else
						Mov Eax, [Ebx].chrPos.lMin
						Mov lTemp, Eax
						Mov Eax, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMin, Eax
						Invoke rsFindNextWord, Ebx, lTemp
						Mov [Ebx].chrPos.lMax, Eax
					.EndIf
				.Else
					Mov Eax, [Ebx].chrSel.lMin
					.If [Ebx].chrSel.lMax == Eax
						Mov Eax, [Ebx].chrPos.lMax
						.If Eax < lTemp
							Invoke rsFindNextWord, Ebx, [Ebx].chrPos.lMax
							Mov [Ebx].chrPos.lMax, Eax
							Mov [Ebx].chrPos.lMin, Eax
						.EndIf
					.Else
						Mov Eax, [Ebx].chrPos.lMax
						Mov [Ebx].chrPos.lMin, Eax
					.EndIf
				.EndIf
			.ElseIf bShift
				Mov Eax, [Ebx].chrSel.lMax
				.If Eax >= [Ebx].chrSel.lMin
					Mov Eax, [Ebx].chrPos.lMax
					.If Eax < lTemp
						Inc [Ebx].chrPos.lMax
					.EndIf
				.Else
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].chrPos.lMin, Eax
					Mov Eax, [Ebx].chrSel.lMax
					Mov [Ebx].chrPos.lMax, Eax
					.If Eax < [Ebx].lTextLength
						Inc [Ebx].chrPos.lMax
					.EndIf
				.EndIf
			.Else
				Mov Eax, [Ebx].chrSel.lMin
				.If Eax == [Ebx].chrSel.lMax
					Mov Eax, [Ebx].chrPos.lMax
					.If Eax < lTemp
						Inc Eax
						Mov [Ebx].chrPos.lMax, Eax
						Mov [Ebx].chrPos.lMin, Eax
					.EndIf
				.Else
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].chrPos.lMin, Eax
				.EndIf
			.EndIf
			Mov Eax, [Ebx].lpszText
			Add Eax, [Ebx].chrPos.lMax
			.If Byte Ptr [Eax] == 10
				Mov Eax, [Ebx].chrPos.lMin
				.If Eax == [Ebx].chrPos.lMax
					Inc [Ebx].chrPos.lMin
				.EndIf
				Inc [Ebx].chrPos.lMax
			.EndIf
			Mov [Ebx].bSelCol, TRUE
		.ElseIf wParam == VK_UP
			.If bCtrl && bShift
				Return 0
			.ElseIf bCtrl && !bShift
				.If [Ebx].lFirstLine > 0
					Invoke rsLineScroll, Ebx, 0, (-1)
					Invoke InvalidateRect, hWnd, NULL, FALSE
				.Else
					Return 0
				.EndIf
			.EndIf
			Invoke rsGetPrevLineIndex, Ebx, [Ebx].lLineIndex
			Mov [Ebx].lLineIndex, Eax
			Mov lTemp, Eax
			Mov Eax, [Ebx].lSelCol
			Mov [Ebx].ptPos.x, Eax
			Invoke rsGetMemoryPosition, Ebx
			Add lTemp, Eax
			Mov Eax, [Ebx].chrSel.lMax
			.If Eax < [Ebx].chrSel.lMin
				Mov Eax, [Ebx].chrPos.lMax
				Mov [Ebx].chrPos.lMin, Eax
			.EndIf
			Mov Eax, lTemp
			Mov [Ebx].chrPos.lMax, Eax
			Invoke rsGetLineLength, Ebx, [Ebx].lLineIndex
			Mov lTemp, Eax
			Mov Eax, [Ebx].chrPos.lMax
			Sub Eax, [Ebx].lLineIndex
			.If Eax >= lTemp
				.If bShift
					Mov Eax, [Ebx].lLineIndex
					Add Eax, lTemp
					Inc Eax
					Mov [Ebx].chrPos.lMax, Eax
				.Else
					Mov Eax, [Ebx].lLineIndex
					Add Eax, lTemp
					Dec Eax
					Mov [Ebx].chrPos.lMax, Eax
				.EndIf
			.EndIf
			.If !bShift
				Mov Eax, [Ebx].chrSel.lMin
				.If Eax < [Ebx].chrSel.lMax
					Invoke rsGetPrevLineIndex, Ebx, [Ebx].chrPos.lMin
					Mov [Ebx].chrPos.lMax, Eax
					Mov Eax, [Ebx].lSelCol
					Mov [Ebx].ptPos.x, Eax
					Invoke rsGetMemoryPosition, Ebx
					Add [Ebx].chrPos.lMax, Eax
				.EndIf
				Mov Eax, [Ebx].chrPos.lMax
				Mov [Ebx].chrPos.lMin, Eax
			.EndIf
			Mov [Ebx].bSelCol, FALSE
		.ElseIf wParam == VK_DOWN
			Mov Eax, [Ebx].lTextLength
			Mov lTemp, Eax
			.If [Ebx].chrPos.lMax >= Eax
				.If Eax == [Ebx].chrPos.lMin
					Return 0
				.EndIf
			.EndIf
			.If bCtrl && bShift
				Return 0
			.ElseIf bCtrl && !bShift
				Mov Eax, [Ebx].lRows
				Sub Eax, [Ebx].lPageSize
				Dec Eax
				.If [Ebx].lFirstLine < Eax
					Invoke rsLineScroll, Ebx, 0, 1
					Invoke InvalidateRect, hWnd, NULL, FALSE
				.Else
					Return 0
				.EndIf
			.EndIf
			Invoke rsGetNextLineIndex, Ebx, [Ebx].lLineIndex
			Mov [Ebx].lLineIndex, Eax
			.If Eax < lTemp
				Mov Eax, [Ebx].lSelCol
				Mov [Ebx].ptPos.x, Eax
				Invoke rsGetMemoryPosition, Ebx
				Add Eax, [Ebx].lLineIndex
				Mov lTemp, Eax
			.EndIf
			Mov Eax, [Ebx].chrSel.lMax
			.If Eax < [Ebx].chrSel.lMin
				Mov Eax, [Ebx].chrPos.lMax
				Mov [Ebx].chrPos.lMin, Eax
			.EndIf
			Mov Eax, lTemp
			Mov [Ebx].chrPos.lMax, Eax
			Invoke rsGetLineLength, Ebx, [Ebx].lLineIndex
			Mov lTemp, Eax
			Mov Eax, [Ebx].chrPos.lMax
			Sub Eax, [Ebx].lLineIndex
			.If lTemp > 0 && Eax >= lTemp
				.If bShift
					Mov Eax, [Ebx].lLineIndex
					Add Eax, lTemp
					Inc Eax
					Mov [Ebx].chrPos.lMax, Eax
				.Else
					Mov Eax, [Ebx].lLineIndex
					Add Eax, lTemp
					Dec Eax
					Mov [Ebx].chrPos.lMax, Eax
				.EndIf
			.EndIf
			.If !bShift
				Mov Eax, [Ebx].chrSel.lMax
				.If [Ebx].chrSel.lMin > Eax
					Invoke rsGetNextLineIndex, Ebx, [Ebx].chrPos.lMin
					Mov [Ebx].chrPos.lMax, Eax
					Mov Eax, [Ebx].lSelCol
					Mov [Ebx].ptPos.x, Eax
					Invoke rsGetMemoryPosition, Ebx
					Add [Ebx].chrPos.lMax, Eax
				.EndIf
				Mov Eax, [Ebx].chrPos.lMax
				Mov [Ebx].chrPos.lMin, Eax
			.EndIf
			Mov [Ebx].bSelCol, FALSE
		.ElseIf wParam == VK_PRIOR
			.If !bCtrl
				.If [Ebx].lLineIndex == 0
					Mov Eax, [Ebx].chrPos.lMax
					.If Eax == [Ebx].chrPos.lMin
						Return 0
					.EndIf
				.EndIf
				Push Edx
				Mov Edx, [Ebx].lFirstLine
				Sub Edx, [Ebx].lPageSize
				.If Edx >= [Ebx].lFirstLine
					Sub Edx, [Ebx].lPageSize
				.EndIf
				Mov Eax, Edx
				Sub Eax, [Ebx].lPageSize
				.If Eax >= 80000000H ;< 0
					Xor Edx, Edx
				.EndIf
				Mov Eax, [Ebx].ptPos.y
				Sub Eax, [Ebx].lFirstLine
				Mov lTemp, Eax
				Mov Eax, [Ebx].lFirstLine
				Sub Eax, lTemp
				.If Eax >= 80000000H ;< 0
					Mov lTemp, Edx
				.EndIf
				Invoke rsGetLineIndex, Ebx, Edx
				Mov [Ebx].lLineIndex, Eax
				Mov [Ebx].lFirstLine, Edx
				Mov Eax, [Ebx].lLineIndex
				Mov [Ebx].lFirstLineIndex, Eax
				Add Edx, lTemp
				Invoke rsGetLineIndex, Ebx, Edx
				Mov [Ebx].lLineIndex, Eax
				.If Eax < [Ebx].lTextLength
					Mov Eax, [Ebx].lSelCol
					Mov [Ebx].ptPos.x, Eax
					Mov Edx, [Ebx].lLineIndex
					Invoke rsGetMemoryPosition, Ebx
					Add Edx, Eax
					Mov [Ebx].lLineIndex, Edx
					Mov Eax, Edx
				.EndIf
				Pop Edx
				Mov [Ebx].chrPos.lMax, Eax
				.If bShift
					Mov Eax, [Ebx].chrSel.lMin
					Mov [Ebx].chrPos.lMin, Eax
				.Else
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].chrPos.lMin, Eax
				.EndIf
				Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			.EndIf
			Mov [Ebx].bSelCol, FALSE
		.ElseIf wParam == VK_NEXT
			.If !bCtrl
				Mov Eax, [Ebx].lLineIndex
				.If Eax >= [Ebx].lTextLength
					Mov Eax, [Ebx].chrPos.lMax
					.If Eax == [Ebx].chrPos.lMin
						Return 0
					.EndIf
				.EndIf
				Push Edx
				Mov Eax, [Ebx].lFirstLine
				Mov Edx, Eax
				Add Eax, [Ebx].lPageSize
				.If Edx < Eax
					Add Edx, [Ebx].lPageSize
				.EndIf
				Mov Eax, Edx
				Add Eax, [Ebx].lPageSize
				.If Eax >= [Ebx].lRows
					Mov Edx, [Ebx].lRows
					Dec Edx
					Sub Edx, [Ebx].lPageSize
				.EndIf
				.If Edx >= 80000000H ; < 0
					Mov Eax, [Ebx].lTextLength
					Mov [Ebx].chrPos.lMax, Eax
				.Else
					Mov Eax, [Ebx].ptPos.y
					Sub Eax, [Ebx].lFirstLine
					Mov lTemp, Eax
					Add Eax, [Ebx].lFirstLine
					Add Eax, [Ebx].lPageSize
					Inc Eax
					Push Ecx
					Mov Ecx, [Ebx].lRows
					Dec Ecx
					.If Eax >= Ecx
						Sub Ecx, Edx
						Mov lTemp, Ecx
					.EndIf
					Pop Ecx
					Invoke rsGetLineIndex, Ebx, Edx
					Mov [Ebx].lLineIndex, Eax
					Mov [Ebx].lFirstLine, Edx
					Mov [Ebx].lFirstLineIndex, Eax
					Add Edx, lTemp
					Invoke rsGetLineIndex, Ebx, Edx
					Mov [Ebx].lLineIndex, Eax
					.If Eax < [Ebx].lTextLength
						Mov Eax, [Ebx].lSelCol
						Mov [Ebx].ptPos.x, Eax
						Invoke rsGetMemoryPosition, Ebx
						Add Eax, [Ebx].lLineIndex
						Mov [Ebx].lLineIndex, Eax
					.EndIf
					Mov [Ebx].chrPos.lMax, Eax
				.EndIf
				Pop Edx
				.If bShift
					Mov Eax, [Ebx].chrSel.lMin
					Mov [Ebx].chrPos.lMin, Eax
				.Else
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].chrPos.lMin, Eax
				.EndIf
				Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			.EndIf
			Mov [Ebx].bSelCol, FALSE
		.EndIf
		Push Ecx
		Mov Eax, chr.lMin
		Mov Ecx, chr.lMax
		.If [Ebx].chrPos.lMin != Eax || [Ebx].chrPos.lMax != Ecx
			Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
		.Else
			Push [Ebx].dwEventMask
			Mov [Ebx].dwEventMask, 0
			Mov Eax, [Ebx].lFirstLine
			Add Eax, [Ebx].ptPos.y
			.If Eax > [Ebx].lPageSize
				Invoke rsSetSelection, Ebx, [Ebx].chrSel.lMin, [Ebx].chrSel.lMax
			.ElseIf Eax < [Ebx].lFirstLine
				Invoke rsSetSelection, Ebx, [Ebx].chrSel.lMin, [Ebx].chrSel.lMax
			.Else
				.If [Ebx].bSelCol
					Mov [Ebx].bSelCol, FALSE
					Mov Eax, [Ebx].lRealCol
					Mov [Ebx].lSelCol, Eax
				.EndIf
			.EndIf
			Pop [Ebx].dwEventMask
		.EndIf
		Pop Ecx
		Return 0
	.ElseIf uMsg == WM_CHAR
		.If wParam == VK_ESCAPE
			Return 0
		.ElseIf wParam == 3 ; Ctrl+C
			Return 0
		.ElseIf wParam == 22 ; Ctrl+V
			Return 0
		.ElseIf wParam == 24 ; Ctrl+X
			Return 0
		.ElseIf wParam == 25 ; Ctrl+Y
			Return 0
		.ElseIf wParam == 26 ; Ctrl+Z
			Return 0
		.ElseIf wParam == VK_RETURN
			Invoke rsSendNotifyMessage, Ebx, NM_RETURN
			Mov Eax, [Ebx].bAutoIndent
			.If Eax
				Push Esi
				Push Edi
				Invoke GlobalAlloc, GMEM_FIXED Or GMEM_ZEROINIT, 1024
				Mov Edi, Eax
				Mov lTemp, Eax
				Mov Ax, 0A0DH
				Stosw
				Mov Esi, [Ebx].lLineIndex
				Add Esi, [Ebx].lpszText
				.While Byte Ptr [Esi]
					Lodsb
					.If Al != ' ' && Al != 9
						.Break
					.EndIf
					Stosb
				.EndW
				Invoke rsReplaceSelection, Ebx, lTemp, wParam
				Invoke GlobalFree, lTemp
				Pop Edi
				Pop Esi
			.Else
				Invoke rsReplaceSelection, Ebx, Addr szLineFeed, wParam
			.EndIf
		.ElseIf wParam == VK_BACK
			Mov Byte Ptr szChar[0], 0
			Mov Byte Ptr szChar[1], 0
			Mov Eax, [Ebx].chrPos.lMin
			.If Eax == [Ebx].chrPos.lMax
				.If Eax > 0
					Dec Eax
					Mov [Ebx].chrPos.lMin, Eax
					Add Eax, [Ebx].lpszText
					.If Byte Ptr [Eax] == 10
						Dec [Ebx].chrPos.lMin
					.EndIf
				.Else
					Return 0
				.EndIf
			.EndIf
			Invoke rsReplaceSelection, Ebx, Addr szChar, wParam
		.ElseIf [Ebx].lRealCols > 1023
			Invoke MessageBeep, 0
			Return 0
		.ElseIf wParam == VK_TAB || wParam > 31
			LoWord wParam
			Mov Byte Ptr szChar[0], Al
			Mov Byte Ptr szChar[1], 0
			Mov Eax, [Ebx].chrPos.lMax
			.If Eax == [Ebx].chrPos.lMin
				Add Eax, [Ebx].lpszText
				.If ![Ebx].bInsert && Byte Ptr [Eax] != 13
					Sub Eax, [Ebx].lpszText
					.If Eax <= [Ebx].lTextLength
						Inc [Ebx].chrPos.lMax
					.EndIf
				.EndIf
			.EndIf
			Invoke rsReplaceSelection, Ebx, Addr szChar, wParam
		.EndIf
		Return 0
	.ElseIf uMsg == WM_LBUTTONDOWN
		Invoke SetFocus, hWnd
		Invoke rsProcessLButtonDown, Ebx, uMsg, wParam, lParam
		.If ((wParam & MK_SHIFT) || (wParam & MK_CONTROL))
			Mov Eax, [Ebx].chrSel.lMin
		.EndIf
		Mov [Ebx].lStart, Eax
		Invoke SetCapture, hWnd
		Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
		Return 0
	.ElseIf uMsg == WM_LBUTTONDBLCLK
		Invoke rsSendNotifyMessage, Ebx, NM_DBLCLK
		Invoke rsSelectWord, Ebx, [Ebx].chrPos.lMin, FALSE
		Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
		Return 0
	.ElseIf uMsg == WM_MOUSEMOVE
		.If (wParam & MK_LBUTTON)
			Invoke GetCapture
			.If Eax == hWnd
				Invoke rsProcessLButtonDown, Ebx, uMsg, wParam, lParam
				Mov Eax, [Ebx].chrPos.lMax
				.If Eax > [Ebx].lStart
					.If ((wParam & MK_SHIFT) || (wParam & MK_CONTROL))
						Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
					.Else
						Invoke rsSetSelection, Ebx, [Ebx].lStart, [Ebx].chrPos.lMax
					.EndIf
				.Else
					.If ((wParam & MK_SHIFT) || (wParam & MK_CONTROL))
						Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
					.Else
						Invoke rsSetSelection, Ebx, [Ebx].lStart, [Ebx].chrPos.lMin
					.EndIf
				.EndIf
						.EndIf
		.EndIf
		Return 0
	.ElseIf uMsg == WM_RBUTTONDOWN
		Invoke SetFocus, hWnd
		Invoke rsSendNotifyMessage, Ebx, NM_RCLICK
		Mov Eax, [Ebx].chrPos.lMin
		Mov chr.lMin, Eax
		Mov Eax, [Ebx].chrPos.lMax
		Mov chr.lMax, Eax
		Invoke rsProcessLButtonDown, Ebx, uMsg, wParam, lParam
		Mov Eax, [Ebx].chrPos.lMin
		Mov Edx, [Ebx].chrPos.lMax
		.If Eax < chr.lMin || Edx > chr.lMax
			Invoke rsSetSelection, Ebx, [Ebx].chrPos.lMin, [Ebx].chrPos.lMax
		.Else
			Mov Eax, chr.lMin
			Mov [Ebx].chrPos.lMin, Eax
			Mov Eax, chr.lMax
			Mov [Ebx].chrPos.lMax, Eax
		.EndIf
		Return 0
	.ElseIf uMsg == WM_RBUTTONDBLCLK
		Invoke rsSendNotifyMessage, Ebx, NM_RDBLCLK
		Return 0
	.ElseIf uMsg == WM_LBUTTONUP
		Invoke GetCapture
		.If Eax == hWnd
			Invoke rsSendNotifyMessage, Ebx, NM_CLICK
		.EndIf
		Invoke ReleaseCapture
		Return 0
	.ElseIf uMsg == WM_RBUTTONUP
		Invoke rsSendNotifyMessage, Ebx, NM_RCLICK
		Return 0
	.ElseIf uMsg == WM_MOUSEWHEEL
		HiWord wParam
		Cmp Ax, 0
		.If Sign?
			Mov Eax, 3
		.Else
			.If [Ebx].lFirstLine == 0
				Ret
			.ElseIf [Ebx].lFirstLine >= 3
				Mov Eax, (-3)
			.Else
				Mov Eax, [Ebx].lFirstLine
				Neg Eax
			.EndIf
		.EndIf
		Invoke rsLineScroll, Ebx, 0, Eax
		Invoke rsUpdateScrollBars, Ebx, TRUE
		Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
		Invoke rsSetCaret, Ebx
		Return 0
	.ElseIf uMsg == WM_SIZE
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		LoWord lParam
		.If Ax > 0
			Mov [Ebx].szSize.x, Eax
			HiWord lParam
			Mov [Ebx].szSize.y, Eax
			Invoke rsUpdateScrollBars, Ebx, FALSE
			Invoke IsWindowVisible, hWnd
			.If Eax
				Invoke rsSetCaret, Ebx
			.EndIf
		.EndIf
		Return 0
	.ElseIf uMsg == WM_NCDESTROY
		Invoke DeleteObject, [Ebx].hFont
		Invoke DeleteObject, [Ebx].hBackBrush
		Invoke DeleteObject, [Ebx].hSelBarBrush
		Invoke DeleteObject, [Ebx].hBitmap
		Invoke DeleteDC, [Ebx].hMem
		Invoke rsClearUndoBuffer, Ebx
		Invoke GlobalFree, [Ebx].lpszLine
		Invoke GlobalFree, [Ebx].lpszUndoText
		Invoke GlobalFree, [Ebx].lpUndoBuffer
		Invoke VirtualFree, [Ebx].lpszMemPtr, 0, MEM_RELEASE
	.EndIf
	Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	Ret
wndRSEditWndProc EndP


;===========================================================================
; Selection bar window procedure
;===========================================================================

wndSelBarWndProc Proc Uses Ebx hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local lCursor:LONG, wndOldProc:DWord
	Local pt:POINTL

	Invoke GetWindowLong, hWnd, GWL_USERDATA
	Mov wndOldProc, Eax
	Invoke GetParent, hWnd
	Invoke GetWindowLong, Eax, GWL_USERDATA
	GetEditData Eax
	.If uMsg == WM_SETCURSOR
		Mov Eax, IDC_CURSOR
		Invoke LoadCursor, hInst, Eax
		Invoke SetClassLong, hWnd, GCL_HCURSOR, Eax
		Mov lCursor, Eax
		Invoke CallWindowProc, wndOldProc, hWnd, uMsg, wParam, lParam
		Invoke SetClassLong, hWnd, GCL_HCURSOR, lCursor
		Invoke DeleteObject, Eax
		Return TRUE
	.ElseIf uMsg == WM_LBUTTONDOWN
		Invoke SetCapture, hWnd
		Invoke SetFocus, [Ebx].hWnd
		.If (wParam & MK_CONTROL)
			.If (wParam & MK_SHIFT)
				Invoke rsSetSelection, Ebx, 0, [Ebx].lTextLength
			.Else
				Invoke rsSetPosition, Ebx, 0, [Ebx].lTextLength
				Invoke rsSetCursorCoordinates, Ebx
				Invoke rsSetCaret, Ebx
			.EndIf
			Mov [Ebx].lSelCol, Eax
			Invoke InvalidateRect, [Ebx].hWnd, NULL, FALSE
			Return 0
		.EndIf
		Push Edx
		HiWord lParam
		Cwde
		Cdq
		IDiv [Ebx].szFont.y
		Add Eax, [Ebx].lFirstLine
		Pop Edx
		.If Eax >= [Ebx].lRows || Eax >= 80000000H ;< 0
			Return 0
		.EndIf
		Mov pt.y, Eax
		Invoke rsGetLineIndex, Ebx, Eax
		Mov [Ebx].lStart, Eax
		Invoke rsGetLineLength, Ebx, Eax
		Cmp Eax, 0
		Jg @F
		Return 0
@@:		Inc Eax
		Mov pt.x, Eax
		Mov Eax, [Ebx].lStart
		Mov [Ebx].lStartPos, Eax
		.If (wParam & MK_SHIFT)
			Mov pt.x, Eax
			.If [Ebx].chrSel.lMin > Eax
				Invoke rsGetLineFromChar, Ebx, [Ebx].chrSel.lMin, FALSE
				Invoke rsGetLineIndex, Ebx, Eax
				Mov [Ebx].lStart, Eax
				Invoke rsGetLineLength, Ebx, [Ebx].lStart
				Inc Eax
				Add Eax, [Ebx].lStart
				Mov [Ebx].lStartPos, Eax
			.Else
				Mov Eax, [Ebx].chrSel.lMin
				.If Eax > [Ebx].chrSel.lMax
					Dec Eax
					Invoke rsGetLineFromChar, Ebx, Eax, FALSE
				.Else
					Invoke rsGetLineFromChar, Ebx, [Ebx].chrSel.lMin, FALSE
				.EndIf
				Invoke rsGetLineIndex, Ebx, Eax
				Mov [Ebx].lStart, Eax
				Invoke rsGetLineLength, Ebx, pt.x
				Inc Eax
				Add pt.x, Eax
				Mov Eax, [Ebx].lStart
				Mov [Ebx].lStartPos, Eax
			.EndIf
		.Else
			Add pt.x, Eax
		.EndIf
		Mov [Ebx].bSelCol, TRUE
		Invoke rsSetSelection, Ebx, [Ebx].lStartPos, pt.x
		Return 0
	.ElseIf uMsg == WM_MOUSEMOVE
		.If (wParam & MK_LBUTTON)
			Invoke GetKeyState, VK_CONTROL
			Cmp Ax, 0
			Jge @F
			Return 0
@@:			Push Edx
			HiWord lParam
			Cwde
			Cdq
			IDiv [Ebx].szFont.y
			Add Eax, [Ebx].lFirstLine
			Pop Edx
			Cmp Eax, 0
			Jge @F
			Xor Eax, Eax
@@:			Cmp Eax, [Ebx].lRows
			Jl @F
			Mov Eax, [Ebx].lRows
			Dec Eax
@@:			Mov pt.y, Eax
			Invoke rsGetLineIndex, Ebx, Eax
			Mov pt.x, Eax
			.If Eax < [Ebx].lStart
				Mov pt.x, Eax
				.If [Ebx].lStart > 0
					Mov Eax, [Ebx].chrPos.lMax
					Mov [Ebx].lStartPos, Eax
				.EndIf
			.Else
				Mov Eax, [Ebx].lStart
				Mov [Ebx].lStartPos, Eax
				Invoke rsGetLineLength, Ebx, pt.x
				Cmp Eax, 0
				Jge @F
				Return 0
@@:				Inc Eax
				Add pt.x, Eax
			.EndIf
			Invoke rsSetSelection, Ebx, [Ebx].lStartPos, pt.x
			Return 0
		.EndIf
	.ElseIf uMsg == WM_LBUTTONUP
		Invoke ReleaseCapture
		Return 0
	.EndIf
	Invoke CallWindowProc, wndOldProc, hWnd, uMsg, wParam, lParam
	Ret
wndSelBarWndProc EndP

End DllMain
